<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-01-14 15:57:14 -0400 (lu., 14 ene. 2019) $
 * @version        $Rev: 10466 $
 * @package		Clientix.Classes.Listing
 * @abstract		General Class
 * CHANGE LOG
 *  Included label
 */
class xPaging {

    var $specs;
    var $debug = false;
//    var $debug = true;

    function __construct() {
        $this->specs = array();
		
        $this->specs['rpp'] = (!empty($_SESSION['prefs']['PAGING_RPP'])) ? $_SESSION['prefs']['PAGING_RPP'] : CLX_NUM_ONE;
        $this->specs['singular'] = 'record';
        $this->specs['plural'] = 'records';
        $this->specs['selector'] = CLX_NUM_ONE;
        $this->specs['printheaders'] = true;
        $this->specs['FILTER'] = false;
        $this->specs['exeonsearch'] = false;
        $this->specs['retrieved_records'] = CLX_INIT_ZERO;
        $this->specs['showhistory'] = CLX_INIT_ZERO;
        $this->specs['formname'] = '';
        $this->specs['li'] = '';
		$this->querycode='';
		IF (ISSET($_SESSION['ADDRDEBUGXPAGGING']) && $_SESSION['ADDRDEBUGXPAGGING']==$_SERVER['REMOTE_ADDR']) {
			$this->debug=true;
		}
    }

    function setProp($name, $value) {
        $this->specs[$name] = $value;
    }

    function getProp($name) {
        return $this->specs[$name];
    }

    function initPagingHistory($formname) {
        $this->specs['formname'] = $formname; 
        if (!isset($_SESSION['paging'][$formname])) {
            $_SESSION['paging'][$formname] = array();
            $_SESSION['paging'][$formname]['criteria'] = '';
            $_SESSION['paging'][$formname]['sortby'] = '';
            $_SESSION['paging'][$formname]['startat'] = CLX_INIT_ZERO;
            $_SESSION['paging'][$formname]['showhistory'] = CLX_INIT_ZERO;
        }
        if (!isset($_SESSION['paging'][$formname]['criteria']))
            $_SESSION['paging'][$formname]['criteria'] = '';
        if (!isset($_SESSION['paging'][$formname]['sortby']))
            $_SESSION['paging'][$formname]['sortby'] = '';
        if (!isset($_SESSION['paging'][$formname]['startat'])) {
			$_SESSION['paging'][$formname]['startat'] = CLX_INIT_ZERO;
		}	
        if (!isset($_SESSION['paging'][$formname]['showhistory'])) 
            $_SESSION['paging'][$formname]['showhistory'] = CLX_INIT_ZERO;
        if (isset(UserRequest::$request['startat'])) { 
			//not using $request in if not equal value to $get
			if (empty(UserRequest::$get['to']) ||UserRequest::$get['to']=='EDIT' || UserRequest::$get['to']=='UILG' ||UserRequest::$get['to']==substr($formname,0,4)) {
				$_SESSION['paging'][$formname]['startat'] = UserRequest::$request['startat'];
			}
			else if (UserRequest::$get['to']=='UIPG') {///no utilizar en este caso UserRequest::$request trae valores distintos
				$_SESSION['paging'][$formname][UserRequest::$get['li']]['startat'] =UserRequest::$get['startat'];
			}			
        }
        if (array_key_exists('showhistory', UserRequest::$request)) {
            $_SESSION['paging'][$formname]['showhistory'] = (!empty(UserRequest::$request['showhistory'])) ? true : false;
        }
        //Setting history
        $this->specs['showhistory'] = $_SESSION['paging'][$formname]['showhistory'];
    }
	function replace_query_width($criteria,$startat) {
		if (isset($this->addviewcolumn))
			$columnadds=$this->addviewcolumn;
		else
			$columnadds=array();
		$wherequeryeditinternal='';
		$wherequeryeditexternal='';
		$tablecodeedit=array();
		$limitinternal='';
		$limitexternal='';
		$textfields='';
		$queryedit='';
		$qty_sql='';
		$nom=false;
			$queryedit= html_entity_decode(ClxCommon::$db->getOne( $SQL='SELECT TEXT_SQL FROM CLX_DB_QUERY_SAVE DBQS,CLX_DB_QUERIES DBQY WHERE DBQY.`VIEW_TYPE`=1 AND DBQS.QUERYCODE=DBQY.IDCODE AND DBQY.IDCODE='.singlequote($this->querycode)),ENT_QUOTES) ;
			IF (!empty($queryedit)) { 
				$internal=true;
				$pos1= strpos($queryedit,'/*INITFIELDINTERNAL*/');
				$pos2= strpos($queryedit,'/*ENDFIELDINTERNAL*/');
				if ($pos1>0 && $pos2>0 && $pos1<$pos2) {
					
					$fields=$fields2=preg_split("/[\(\=\,\s]/",$textfields=trim(substr($queryedit,$pos1+21,$pos2-$pos1-21)));
					$letra='';
					foreach($fields as  $key=>&$valuex) {
						$pos1=strpos($valuex,".");
						if ($pos1==5) {
							$tablecodeedit[substr($valuex,0,5)]=array(substr($valuex,0,5),substr($valuex,0,4));
							
							$valuex=trim(substr($valuex,0,4).substr($valuex,5));
						}
					}
					$ctfields=preg_split("/[\(\=\,\s]/",$criteria);
					//pre($ctfields);
					
					
					foreach ($ctfields as $key=>$value) {
					
						if ((preg_match('/^[0-9\.]*$/', trim($value)) || 
							preg_match('/[\'\"\<\>]/', trim($value))) || strtolower($value)=='like') {
							// !  )){
						//	echo $value.',,';
							
						}
						else if (array_search(trim($value),  $fields)===false){
						//	pre( substr($value,0,5)."==".substr($fields[0],0,5));
							$nom=true;
							
						}
					}
				}
				else if (empty($criteria)) {
				}
				else {
					$queryedit=str_replace( '/*INITFIELDINTERNAL*/','',$queryedit);
					$queryedit=str_replace( '/*ENDFIELDINTERNAL*/','',$queryedit);
					$internal=false;	
				
		  		
				}
				/*IF ($_SERVER['REMOTE_ADDR']=='201.211.248.250') {
						PRE($pos1);
						pre($pos2);
						pre($nom);
					}
				*/
				
				if ($nom==false){
					$wherequeryeditinternal=$criteria;
					foreach( $tablecodeedit as $vale) {
						$wherequeryeditinternal=str_replace($vale[1].'.',$vale[0].'.',$wherequeryeditinternal);
					}
					$limitexternal='';
					$limitinternal=' LIMIT ' . $startat . ',' . $this->specs['rpp'];
				}
				else {
					$wherequeryeditexternal=$criteria;
					$limitinternal='';
					$limitexternal=' LIMIT ' . $startat . ',' . $this->specs['rpp'];
				}
				
				if ($internal) {
					if ($this->specs['exeonsearch'] === true && empty($criteria) ) {
						$wherequeryeditinternal= (empty($wherequeryeditinternal)?  '': 'AND').' 2=1 ';
						$wherequeryeditexternal= (empty($wherequeryeditexternal)?  '': 'AND').' 2=1 ';
					}
					
					$queryedit=str_replace('/*WHEREINTERNAL*/',empty($wherequeryeditinternal)? '' :' AND '.$wherequeryeditinternal,$queryedit);
					$queryedit=str_replace('/*WHEREEXTERNAL*/',empty($wherequeryeditexternal)? '' :' AND '.$wherequeryeditexternal,$queryedit);	
					
					$queryedit=str_replace('/*NOTWHEREINTERNAL*/',empty($wherequeryeditinternal)? '' : ' WHERE '.$wherequeryeditinternal,$queryedit);
					$queryedit=str_replace('/*NOTWHEREEXTERNAL*/',empty($wherequeryeditexternal)? '' : ' WHERE '.$wherequeryeditexternal,$queryedit);	
					
					$queryedit=str_replace('/*INITFIELDINTERNAL*/','',$queryedit);
					$queryedit=str_replace('/*ENDFIELDINTERNAL*/','',$queryedit);
					//pre($queryedit);
				}
				else {
					if ($this->specs['exeonsearch'] === true && empty($criteria) ) {
						$criteria=(empty($criteria) ? '': 'AND').' 2=1 ';
					
					}
					$queryedit=str_replace('/*WHEREEXTERNAL*/',empty($criteria)? '' :' AND '.$criteria,$queryedit);	
					$queryedit=str_replace('/*NOTWHEREEXTERNAL*/',empty($criteria)? '' : ' WHERE '.$criteria,$queryedit);	
					
				}
				
				$queryeditcount=$queryedit;
				$oldqueryedit=$queryedit;
				$queryedit=str_replace('/*LIMITINTERNALPOSITION*/',$limitinternal,$queryedit);
				$queryedit=str_replace('/*LIMITEXTERNALPOSITION*/',$limitexternal,$queryedit);
				if ($queryedit==$oldqueryedit) {
					$queryedit.=' LIMIT ' . $startat . ',' . $this->specs['rpp'];	
				}
				
				if ($nom==false) {
					$pos1=stripos($queryeditcount,'/*INITSELECTCOUNTPRIN*/');
					$pos2=stripos($queryeditcount,'/*ENDSELECTCOUNTPRIN*/');
					if ($pos1>0 && $pos2>0 && $pos1<$pos2) {
						$queryeditcount=trim(substr($queryeditcount,$pos1+23,$pos2-$pos1-23));
						
					}
					if ($this->specs['exeonsearch'] === true && empty($criteria)) {
						preg_match_all('/[\r\n\t\s](FROM\(|FROM\s|FROM\t|FROM\r|FROM\n)/i', $queryedit, $matchesx1, PREG_OFFSET_CAPTURE);
						preg_match_all('/[\r\n\t\s](WHERE\(|WHERE\s|WHERE\t|WHERE\r|WHERE\n)/i', $queryedit, $matchesx2, PREG_OFFSET_CAPTURE);
						$x1=$matchesx1[0][count($matchesx1[0])-1][1];
						$x2=$matchesx2[0][count($matchesx2[0])-1][1];
						if ($x1<$x2)
							$queryeditcount.=' AND 2=1';
						else
							$queryeditcount.=' WHERE 2=1';
						
				//		pre($queryeditcount);
				//		$pos=strrupo
					}
				}
				$select_externo='';
				
				if (($poxs=strpos($queryedit,'/*ENDFIELDEXTERNAL*/'))===false) { 
					preg_match('/[\r\n\t\s](FROM\(|FROM\s|FROM\t|FROM\r|FROM\n)/i', $queryedit, $matchesx, PREG_OFFSET_CAPTURE);
					$si=true;
				//	pre($select_Externo);
					$poxs=$matchesx[0][1];
							
					
				}
				else {
					$si=false;
					$select_Externo =substr($queryedit,0,$poxs);
					
				
					$poxs2=strpos($queryedit,'/*INITFIELDEXTERNAL*/');
					$select_Externo =substr($select_Externo,$poxs2+21);
					
					
					$matchesx=array(0=>array(0=>'',1=>$poxs));
				}
				
				$select=substr($queryedit,0,$poxs);
			//	pre($select);
			//	echo'xxxxx2';
				$resto=substr($queryedit,$poxs);
				$select_Externo=preg_split("/[\,]/",$select_Externo);
				foreach($select_Externo as $key=>&$yvalue) {
					$xx=explode(' ',$yvalue);
					$yvalue=$xx[count($xx)-1];
				
				}
			//	pre($select_Externo);
				if (isset($matches[0])) {
					$queryeditcount='SELECT '. singlequote('X').' '.$resto;
				
				}
				//pre($select_Externo);
				if ($poxs>0) {
					
					foreach ($columnadds as $ekey=>$evalue) {
						//$tablefieldname='table_'.$evalue['TABLECODE'];
					//	pre($ekey);
					//	pre($select_Externo);
					//	pre($ekey);
						if (array_search($ekey,$select_Externo)===false) {
						//	echo "[$ekey]","[".$select_Externo[0]."]","<br>";
							
							
							if (empty($evalue['EXPRESSION'])) {
								if (stripos($select,$ekey)===FALSE) {
									$select=$select.',/*OOPPP1*/'.$evalue['TABLECODE'].'.'.$evalue['FIELDNAME'].' '.$ekey;
								}
							}
							else {
								if (stripos($select,$ekey)===FALSE) {
									$select=$select.',/*OOPPP2*/'.$evalue['EXPRESSION'].' '.$ekey;
								}
							}
						}
					}
					
				
				}
				
				$queryedit= $select. ' '. $resto;
				//	$queryeditcount='SELECT '. singlequote('X').' '.SUBSTR($queryeditcount,$pos1);
				
				
				//spre($queryeditcount);
				/*LIMITEXTERNALPOSITION*/
				/*NOTWHEREEXTERNAL*/
				$qty_sql = 'SELECT COUNT(0) QTY FROM ( '.$queryeditcount.' ) DERIVED_TBL';
				$qty_sql=str_replace('/*LIMITINTERNALPOSITION*/','',$qty_sql);
				$qty_sql=str_replace('/*LIMITEXTERNALPOSITION*/','',$qty_sql);
				$queryedit=clx_keywords_simple($queryedit);
				$qty_sql=clx_keywords_simple($qty_sql);
				/*    $qty_sql = str_replace('"!CURDATE"', singlequote( xFormat::getNow($_SESSION['prefs']['DATE_FORMAT'])), $qty_sql);
					$qty_sql = str_replace('"!CURTIME"',singlequote( xFormat::getNow('H:i:s')), $qty_sql);
					$qty_sql = str_replace('"!CURUSER"', singlequote($_SESSION['user_record']['username']), $qty_sql);
					$qty_sql = str_replace('"!CURRENT_DATE"', singlequote(xFormat::getNow($_SESSION['prefs']['DATE_FORMAT'])), $qty_sql);
					$qty_sql = str_replace('"!CURRENT_TIME"', singlequote(xFormat::getNow('H:i:s')), $qty_sql);
					$qty_sql = str_replace('"!CURRENT_DATETIME"',singlequote( xFormat::getNow($_SESSION['prefs']['DATE_FORMAT'].' H:i:s')), $qty_sql);
					$qty_sql = str_replace('"!CURRENT_USERNAME"',singlequote( $_SESSION['user_record']['username']), $qty_sql);
					$qty_sql = str_replace('"!CURRENT_LANGUAGE"', singlequote(getCurrentLanguage()), $qty_sql);
				
		
				preg_match('/(!CURRENT_USERNAME)/',$qty_sql,$mat, PREG_OFFSET_CAPTURE);
				pre(substr($qty_sql,670,12));
				die;*/
				
				
			}
		
		return array($queryedit,$qty_sql);
	
		
	}
	function pageInit($formname, $here, $selectclause, $fromclause, $whereclause, $sortclause, $groupclause = '',$listing='',$fieldsAllquery=array(),$replace=false) {
		IF ($this->debug==true) {echo"parameter xppaging<br>";		PRE(func_get_args()); }
		if ($this->specs['formname'] === '') {
            $this->initPagingHistory($formname);
        }
        $whereclause = trim($whereclause);
        IF ($this->debug==true) {echo"where1<br>";		PRE($whereclause); }
        $criteria = stripslashes($_SESSION['paging'][$formname]['criteria']);
		switch (kDatabaseType) {
            case 'oci': // Solo en Oracle, no va bien con las busquedas LIKE ...%%, asi que deja solo un 
                $criteria = str_replace('%%', '%', $criteria);
                break;
        }
        $sortby = stripslashes($_SESSION['paging'][$formname]['sortby']);
		if (empty($listing)|| !isset($_SESSION['paging'][$formname][$listing]['startat'])) {
			$startat = stripslashes($_SESSION['paging'][$formname]['startat']);//pre($_SESSION['paging'][$formname]['startat']);
			if (!empty($listing) && isset(UserRequest::$get['to']) && UserRequest::$get['to']=='UIPG' ){//paginas con mas de un listado por los momentos solo UIPG linea 69
				$_SESSION['paging'][$formname][$listing]['startat']= $_SESSION['paging'][$formname]['startat'];
			}
        }
		else { //paginas con mas de un listado por los momentos solo UIPG linea 69
			$startat = stripslashes($_SESSION['paging'][$formname][$listing]['startat']);
		}
		//Execute on search
        if ($this->specs['exeonsearch'] === true && empty($criteria)) {
            //Just do noting
            $criteria = ' 2=1 ';
        }

        if (!empty($criteria)) {
            if (empty($whereclause)) {
                $whereclause = 'WHERE ' . $criteria;
                $this->specs['FILTER'] = true;
            } else {
                $whereclause = 'WHERE ' . $whereclause . ' AND ' . $criteria;
                $this->specs['FILTER'] = false;
            }
        } elseif (!empty($whereclause)) {
            $whereclause = 'WHERE ' . $whereclause;
        }
		IF ($this->debug==true) {echo"where2<br>";		PRE($whereclause); }
        if (!empty($sortby)) {
            if (empty($sortclause)) {
                $sortclause = 'ORDER BY ' . $sortby;
            } else {
                $sortclause = 'ORDER BY ' . $sortclause . ', ' . $sortby;
            }
        } elseif (!empty($sortclause)) {
            $sortclause = 'ORDER BY ' . $sortclause;
        }
        if (!empty($groupclause)) {
            $groupclause = 'GROUP BY ' . $groupclause;
        }
			$this->replaceVariables($whereclause);
		$viewEditSql=array(0=>'');
		if ($replace==true) {
			$viewEditSql= $this->replace_query_width($criteria,$startat);
		}
		//if ($_SERVER['REMOTE_ADDR']=='200.93.32.218') {
			if(empty($viewEditSql[0])) {
				$qty_sql = 'SELECT COUNT(0) QTY FROM (SELECT ' . singleQuote('X') . ' FROM ' . $fromclause . ' ' . $whereclause . ' ' . $groupclause . ') DERIVED_TBL';
			}
			else {
				$qty_sql=$viewEditSql[1];
			}
		//}
		///ezse {
		//	$qty_sql = 'SELECT COUNT(0) QTY FROM (SELECT ' . singleQuote('X') . ' FROM ' . $fromclause . ' ' . $whereclause . ' ' . $groupclause . ') DERIVED_TBL';

		//}
		if (!empty($this->debug)) {
            pre($qty_sql);

        }
        ClxCommon::$db->ci_search = true;
		$fetched = false;//echo '--------------xxx-----------';
		
		//pre($_SESSION['history']);
		
		if ($saveq=isset($_SESSION['history']['main'][0]['qy'])) {
			$querycode=$_SESSION['history']['main'][0]['qy'];
			
			if (kApcTtl_22>0) $this->specs['qty'] = apc_fetchFct($findVar=kSpaceName . '_xpagging_count_'.$_SESSION ['user_record']['username'].'_!_'.$querycode.md5($qty_sql), $fetched);

		}
		if (empty($fetched) ) {
			$this->specs['qty'] = $this->countRecords($qty_sql);
			$fromrecord=4000;
			if (defined('kApcTtl_Count_22')){
				$part=explode('>',kApcTtl_Count_22);
				if (is_array($part)and count($part)==2 and is_numeric($part[1]))
					$fromrecord=$part[1];
			}
			if (kApcTtl_22>0 &&$saveq==true && $this->specs['qty']>$fromrecord) {//echo'<br>new apc fetch',$findVar,'<br>';
				apc_addFct($findVar,$this->specs['qty'], kApcTtl_22);  //actualizacion forzada cada 0.75 minutos no ilimitada
			}
		}
        ClxCommon::$db->ci_search = false;
        unset($qty_sql);
		
		$newstatment=$this->reconstruir_query($selectclause,$fromclause,$whereclause,$groupclause,$sortclause,$startat,$this->specs['rpp'], $fieldsAllquery);
		$sialter=0;
        switch (kDatabaseType) {
            case 'oci'://No Mysql 
				$this->specs['statement'] =$newstatment;
                $this->specs['statement'] = 'SELECT ' . $selectclause . ' FROM ' . $fromclause . ' ' . $whereclause . ' ' . $groupclause . ' ' . $sortclause;
                $this->specs['statement'] = ClxCommon::$db->oracle_limit($this->specs['statement'], $startat . ',' . $this->specs['rpp'], $fromclause, $groupclause);
                $this->specs['retrieved_records'] = CLX_NUM_MINUS_1;
                break;
            default://Mysql Version all others
				if ($sialter==0) {
					$this->specs['statement'] =$newstatment;
					$this->specs['statement'] = 'SELECT ' . $selectclause . ' FROM ' . $fromclause . ' ' . $whereclause . ' ' . $groupclause . ' ' . $sortclause . ' LIMIT ' . $startat . ',' . $this->specs['rpp'];
		//	PRE($fromclause);
				
					IF ($formname=='REQUESTS_01_LIST111' || $formname=='MY_REQUESTS_LIST111') {
						$selectclausex='SELECT X.*, 
							ACCO.IDNAME ACCO_IDNAME,ACCO.IBS_CUSCUN SRRQ_IBS_CUSCUN, ACCO.LEGAL_NAME ACCO_LEGAL_NAME ,
							ACCO.IDENTIFICATION ACCO_IDENTIFICATION, ACCO.IDCODE ACCO_IDCODE, IFNULL(ACTI.countx,0) SRRQ_NUM_CASE_WRK ';
						
						$this->specs['statement'] =$selectclausex. ' FROM ('.  
							 $this->specs['statement'].
						')X '.
						'LEFT JOIN CRM_ACCOUNTS ACCO ON X.SRRQ_ACCOUNTCODE = ACCO.IDCODE '.
						'	LEFT JOIN (SELECT COUNT(1) countx,ACTI.REQUESTCODE FROM CRM_ACTIVITIES ACTI WHERE ACTI.ACTIVITY_STATUS <> '.singlequote('F').' GROUP BY ACTI.REQUESTCODE) ACTI ON X.SRRQ_ACCOUNTCODE=ACTI.REQUESTCODE ';

						
					}
					
					$this->specs['retrieved_records'] = CLX_INIT_ZERO;
					break;
				}
				else {
						
					
						$this->specs["statement"] = "SELECT $selectclause 
		                                 FROM $fromclause ". 
										    str_replace('/*FIN_SELECT_COUNT*/' ,'/*FIN_SELECT_COUNT*/'.$sortclause. "  LIMIT $startat,".$this->specs["rpp"]." " ,  $whereclause).
											"   $groupclause ";
							//pre($this->specs["statement"]);
					//	die;
				}					
        }
       
		IF ($this->debug==true) {echo"specs1<br>";		PRE($this->specs['statement']); }
		
        $this->specs['here'] = $here;
        $this->specs['startat'] = $startat;
        $this->specs['selectclause'] = $selectclause;
        $this->specs['fromclause'] = $fromclause;
        $this->specs['whereclause'] = $whereclause;
        $this->specs['sortclause'] = $sortclause;
        $this->specs['groupclause'] = $groupclause;
		IF ($this->debug==true) {echo"specs2<br>";		PRE($this->specs['statement']); }
	    if ($startat >= $this->specs['qty']) {
            $startat = max(CLX_NUM_ZERO, $this->specs['qty'] - $this->specs['rpp']);
            $this->specs['startat'] = max(CLX_NUM_ZERO, $this->specs['qty'] - $this->specs['rpp']);
        }
        if (!empty($this->debug)) {
            pre($this->specs['statement']);
        }
	//	if ($_SERVER['REMOTE_ADDR']=='200.93.32.218') {
			if(empty($viewEditSql[0])) {
				$this->specs['records'] = ClxCommon::$db->executeQueryCi($this->specs['statement']);
			}
			else {
				$this->specs['records'] = ClxCommon::$db->executeQueryCi($viewEditSql[0]);
				
			}
		//}
	//	else {
		//	$this->specs['records'] = ClxCommon::$db->executeQueryCi($this->specs['statement']);

	//	}
     //   $this->specs['records'] = ClxCommon::$db->executeQueryCi($this->specs['statement']);
    }

    /**
     * Retrieve the number of records to display on screen
     *
     * @param string $statement
     * @return integer
     */
    function countRecords($statement) {
		
		$qty = ClxCommon::$db->getOne($statement);
        if (empty($qty)) {
            $qty = CLX_INIT_ZERO;
        }
        return $qty;
    }

    /**
     * Displays the listing header
     */
    function header(&$table) {
        if (($this->specs['printheaders']) || ($this->specs['FILTER'])) {
            $headers = $this->pagingCounter();
            $table->addCell($headers, array(CLX_PROP_CLASS => 'summary', CLX_PROP_COLSPAN => $table->width));
        }
    }

    /**
     * Builds Pager Counter
     * @return string
     */
    function pagingCounter() {
        $qty = $this->specs['qty'];
        $rpp = $this->specs['rpp'];
        $startat = $this->specs['startat'];
        $url = $this->specs['here'];
        if ($this->getProp('li') <> '') {
            $url .='&li=' . $this->getProp('li');
        }
        $table = new htmlTable(CLX_WIDTH_7);
        //Adding History Icon
        $table->addCell(getSkinIcon('firstpagen', $url . '&pop=1&startat=0', dict('GEN_LBL_START', false), CLX_NUM_20, CLX_NUM_19), array(CLX_PROP_CLASS => 'summary', 'valign' => 'middle'));
        if ($startat == CLX_NUM_ZERO) {
            $table->addCell(getSkinIcon('prevpaged', '', dict('GEN_LBL_PREV', true), CLX_NUM_20, CLX_NUM_19), array(CLX_PROP_CLASS => 'summary', 'valign' => 'middle'));
        } else {
            $table->addCell(getSkinIcon('prevpagen', $url . '&pop=1&startat=' . max(CLX_NUM_ZERO, $startat - $rpp), dict('GEN_LBL_PREV', true), CLX_NUM_20, CLX_NUM_19), array(CLX_PROP_CLASS => 'summary', 'valign' => 'middle'));
        }
        if ($startat + $rpp < $qty) {
            $table->addCell(getSkinIcon('nextpagen', $url . '&pop=1&startat=' . ($startat + $rpp), dict('GEN_LBL_NEXT', true), CLX_NUM_20, CLX_NUM_19), array(CLX_PROP_CLASS => 'summary', 'valign' => 'middle'));
        } else {
            $table->addCell(getSkinIcon('nextpaged', '', dict('GEN_LBL_NEXT', true), CLX_NUM_20, CLX_NUM_19), array(CLX_PROP_CLASS => 'summary', 'valign' => 'middle'));
        }
        if ($startat + $rpp < $qty) {
            $table->addCell(getSkinIcon('lastpagen', $url . '&pop=1&startat=' . intval($qty - $rpp), dict('GEN_LBL_LAST', true), CLX_NUM_20, CLX_NUM_19), array(CLX_PROP_CLASS => 'summary', 'valign' => 'middle'));
        } else {
            $table->addCell(getSkinIcon('lastpaged', '', dict('GEN_LBL_LAST', true), CLX_NUM_20, CLX_NUM_19), array(CLX_PROP_CLASS => 'summary', 'valign' => 'middle'));
        }
        //Addind History icon
        if ($this->specs['showhistory'] == CLX_NUM_ONE) {
            //history on
            $table->addCell(getSkinIcon('clockno', $url . '&pop=1&showhistory=0', dict('GEN_LBL_SHOW_HISTORY', false) . '&nbsp); ', CLX_NUM_20, CLX_NUM_19), array(CLX_PROP_CLASS => 'summary', 'valign' => 'middle'));
        } else {
            //History of
            $table->addCell(getSkinIcon('clock', $url . '&pop=1&showhistory=1', dict('GEN_LBL_SHOW_HISTORY', false) . '&nbsp); ', CLX_NUM_20, CLX_NUM_19), array(CLX_PROP_CLASS => 'summary', 'valign' => 'middle'));
        }
        $table->addCell('&nbsp; ' . dict('GEN_LBL_SHOWING') . ': ', array(CLX_PROP_CLASS => 'summary', 'valign' => 'middle'));
        $table->addCell('  PAGERSTART - PAGEREND ' . dict('GEN_LBL_OF') . ' ' . $this->specs['qty'], array(CLX_PROP_CLASS => 'summary', 'valign' => 'middle'));
        return $table->source();
    }

    /**
     * Fetch Next Record on Table
     */
    function nextRecord() {
        if ($this->specs['retrieved_records'] < $this->specs['rpp']) {
            switch (kDatabaseType) {
                case 'oci':
                    ClxCommon::$db->executeQueryCiInitSesVars();
                    break;
            }
            $record = ClxCommon::$db->getNextRecord($this->specs['records']);
            switch (kDatabaseType) {
                case 'oci':
                    ClxCommon::$db->executeQueryCiResetSesVars();
                    break;
            }
            $this->specs['retrieved_records'] ++;
        } else {
            $record = false;
        }
        return $record;
    }

    function footers(&$table, $footers, $disablebutton=true) {
		$script='';
        $qty = $this->specs['qty'];
        $startat = $this->specs['startat'];
        $buttons = $this->pagingCounter();
        if (($this->specs['selector']) and ( $this->specs['qty'] > CLX_NUM_ZERO) and strlen($footers) > CLX_NUM_ZERO) {
            $form = $this->specs['formname'];
            $select = new htmlCheckbox('masive_selector', false);
            $select->setProp('onclick', 'selectAllSelectors(' . singleQuote($form) . ');');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, 'valign' => 'top'));
            $dif = CLX_NUM_ONE;
        } else {
            $dif = CLX_INIT_ZERO;
        }
        $table->addCell($footers, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => max(CLX_NUM_ONE, ($table->width) - $dif)));
        $table->addCell($buttons, array(CLX_PROP_CLASS => 'summary', CLX_PROP_COLSPAN => $table->width));
		if ($disablebutton) {
			$js = 'selectButtons(' . singleQuote($this->specs['formname']) . ');';
			$script = setJavaScriptTag($js, false);
		}
        $contents = $table->source() . CLX_CHAR_NL . CLX_CHAR_NL . $script;
        if (kDatabaseType === 'oci') {
            if ($startat > CLX_NUM_ZERO) {
                $contents = str_replace('PAGERSTART', ($startat+CLX_NUM_ONE), $contents);
                $contents = str_replace('PAGEREND', ($startat + $this->specs['retrieved_records'] /* - CLX_NUM_ONE*/), $contents);
            } else {
                $contents = str_replace('PAGERSTART', min(($startat + CLX_NUM_ONE), $qty), $contents);
                $contents = str_replace('PAGEREND', ($startat + $this->specs['retrieved_records']), $contents);
            }
        } else {
            $contents = str_replace('PAGERSTART', min(($startat + CLX_NUM_ONE), $qty), $contents);
            $contents = str_replace('PAGEREND', min($qty, $startat + $this->specs['retrieved_records']), $contents);
        }
        return $contents;
    }

    function replaceVariables(&$text) {
        $text = clx_keywords_simple($text);
    }

	function reconstruir_query($selectclause,$fromclause,$whereclause,$groupclause,$sortclause,$startat,$rpp,$fieldsAllquery) {
		$fields='';
		
		foreach($fieldsAllquery as $value) {
			if (!empty($value['FIELD'])) {
			$fields.=(($fields<>'') ?',':'').$value['FIELD'].' '.	$value['ALIAS'];
			$selectclause=str_replace($value['FIELD'],'X.'.$value['ALIAS'],$selectclause);
			}
		}

        switch (kDatabaseType) {
            case 'oci': //No Mysql 
                $statement = 'SELECT ' . $fields . ' FROM ' . $fromclause . ' ' . $whereclause . ' ' . $groupclause . ' ' . $sortclause;
				$statement = ClxCommon::$db->oracle_limit($statement, $startat . ',' . $rpp, $fromclause, $groupclause);
			    $statement='SELECT '. $selectclause . ' FROM ('.$statement.') X';
				$this->specs['retrieved_records'] = CLX_NUM_MINUS_1;
                break;
            default://Mysql Version all others
                $statement = 'SELECT ' . $fields . ' FROM ' . $fromclause . ' ' . $whereclause . ' ' . $groupclause . ' ' . $sortclause . ' LIMIT ' . $startat . ',' . $rpp;
				$statement='SELECT '. $selectclause . ' FROM ('.$statement.') X';
                $this->specs['retrieved_records'] = CLX_INIT_ZERO;
                break;
        }

		return 	$statement;
		
	}
	
}
