function guarGuaranteeAmt() {
    var loan = parseInt($('#GUAR_LOAN_AMT').val());
    var pct = parseInt($('#GUAR_GUARANTEE_PCT').val()) / 100;
    $('#GUAR_GUARANTEE_AMT').val(numDec((loan * pct), 2));
    $('#GUAR_LOAN_AMT').val(numDec(loan, 2));
}

function guarInitEndDate() {
    $('#GUAR_END_DATE').val('');
    $('#GUAR_PERIOD_TYPE').val('');
}

function guarSetEndDate() {

    var start_date = $('#GUAR_START_DATE').val().split('-');
    if (start_date[1] == undefined) {
        var dt = new Date();
    } else {
        var dt = new Date(parseInt(start_date[0]),
                (parseInt(start_date[1]) - 1),
                parseInt(start_date[2]));
    }
    if ($('#GUAR_GUARANTEE_PERIOD').val() == '') {
        $('#GUAR_GUARANTEE_PERIOD').val(0);
    }
    var period_type = $('#GUAR_PERIOD_TYPE').val();
    var periods = parseInt($('#GUAR_GUARANTEE_PERIOD').val());

    if (periods == 0) {
        guarInitEndDate();
        return;
    }
    var siretorno=false;
    switch (period_type) {
        case 'H':
            break;
        case 'D':
            dt.setDate(dt.getDate() + (1 * periods));
            break;
        case 'W':
            dt.setDate(dt.getDate() + (7 * periods));
            break;
        case 'M':
            dt.setMonth(dt.getMonth() + (1 * periods));
            break;
        case 'Q':
            dt.setMonth(dt.getMonth() + (3 * periods));
            break;
        case 'S':
            dt.setMonth(dt.getMonth() + (6 * periods));
            break;
        case 'Y':
            dt.setFullYear(dt.getFullYear() + (1 * periods));
            break;
        default:
            $('#GUAR_END_DATE').val('');
            siretorno=true;
            break;
    }//end switch
    if (siretorno)
	return;
    var mt = dt.getMonth() + 1;
    var da = dt.getDate();
    if (mt < 10) {
        mt = '0' + mt;
    }
    if (da < 10) {
        da = '0' + da;
    }
    var end_date = dt.getFullYear() + '-' + mt + '-' + da;
    $('#GUAR_END_DATE').val(end_date);

}//end function
