<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-04-20 08:37:18 -0400 (Fri, 20 Apr 2018) $
 * @version        $Rev: 9795 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Rcaa {
    
    function Rcaa($procParameters = array()) {
		$tta=fopen(kPathToWebSite."/".kPathToTemp."archivorcta2.txt","a+");
		fclose($tta);
        multiTableName($this, array('RCTA'));
       // $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
		$this->debug=false;
		IF (ISSET($_SESSION['ADDRDEBUGRCAA']) && $_SESSION['ADDRDEBUGRCAA']==$_SERVER['REMOTE_ADDR']) {
			$this->debug=true;
		}	


    }

    /**
     * Action from jump listing
     */
    public function build_rcjh_jump_action($action='') {
		
		$contents = '';
        $idlist = getIdlist();
		$idlist_text = implode(",",$idlist);
        if (empty($idlist))
            return;
			
		$msg = array();
		IF ($action=='PEND') {
		 	switch (kDatabaseType) {
				case 'oci': // Oracle

					$sql='UPDATE RCAA_JOURNAL_HDR RCJH SET JEEXP_STAT = '.singlequote('PEND').' WHERE ID IN('.$idlist_text.') AND NVL(JEEXP_STAT,'.singlequote('.').')='.singlequote('.'). ' AND CLX_AUTH_STATUS= '.singlequote('AP') ;
				break;
				default:
						$sql='UPDATE RCAA_JOURNAL_HDR RCJH SET JEEXP_STAT = '.singlequote('PEND').' WHERE ID IN('.$idlist_text.') AND IFNULL(JEEXP_STAT,'.singlequote('.').')='.singlequote('.'). ' AND CLX_AUTH_STATUS= '.singlequote('AP');
					break;
			}
		//	echo $sql;
			ClxCommon::$db->executequery($sql);
		//	PRE(ClxCommon::$db);
			switch (kDatabaseType) {	
				case 'oci':
			
					$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows);
				default:
					$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows);
			}	
		}
		
		else if ($action=='EXPT') { 
			/* Ejecutar Proces RCJX_SAP */
			
			 //pendiente por completar
			$processcode ='RCJX_SAP' ;
		//	$PRSC = &getTool('PRSC');
			$PRPR= &getTool('PRPR');
			$GLOBALS['record']=array();
			if (isset($_SESSION['user_record'])) {
				$GLOBALS['record']=$_SESSION['user_record'];	
				
			}
			//$PRSC->runProcessNow($processcode, $GLOBALS['record']);
			$PRPR->execute_process($processcode, $processcode);
			ob_clean();
			$contents.=$GLOBALS['CONTENTS_EXPORTS'];
			
			$sql='UPDATE RCAA_JOURNAL_HDR RCJH SET JEEXP_STAT = '.singlequote('EXP').' WHERE JEEXP_STAT ='.singlequote('PEND');
			ClxCommon::$db->executequery($sql);
			return $contents;
			
			
		} 
        return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
    }
	
    public function build_rctr_jump_action($action='') {
		
		
        $contents = '';
        $idlist = getIdlist();
		$idlist_text = implode(",",$idlist);
        if (empty($idlist))
            return;
		
		$msg = array();
		IF ($action=='ENLZ') {
			
			
			switch (kDatabaseType) {	
				case 'oci':
					$sql='WITH ';
					$extraWhere='';
					$extraTabla1='';
					$extraTabla2='';
					$extraField='';
					$comma='';
					for ($t=1; $t<6;$t++) {
						
						$sql.=$comma.' X'.$t.' AS ( '.
							' SELECT '.singlequote(',').'||LISTAGG(ID,'.singlequote(',').
							' ON OVERFLOW TRUNCATE) WITHIN GROUP (ORDER BY ID) ||'.singlequote(',').' IDS'.$t.
							' FROM RCAA_SUBLEDGER_TRANS RES1'.$extraTabla1.' WHERE '.
									$extraWhere.' RES1.ITEM_REF_NO IS NULL '.
									' AND  RES1.ID IN('.$idlist_text.'))';
						$extraTabla1.=', X'.$t;
						$extraTabla2.=' X'.$t.",";
						
						$extraWhere.='INSTR(X'.$t.'.IDS'.$t.','.singlequote(',').'||RES1.ID||'.singlequote(',').')<1 '.(($t<5)? ' AND ': '');
						$extraField.='MIN(X'.$t.'.IDS'.$t.') IDS'.$t.(($t<5)? ', ': '');
						$comma=',';
					}
					$sql.=' SELECT  SUM(TRANS_AMT) SUMX,'.$extraField.
							' FROM '. $extraTabla2. ' RCAA_SUBLEDGER_TRANS RES1 WHERE '	.str_replace(')<1',')<>-1',$extraWhere).
									' AND RES1.ITEM_REF_NO IS NULL '.
									' AND RES1.ID IN('.$idlist_text.')'.
									' AND  RES1.CLX_AUTH_STATUS='.singlequote('AP').
							'   GROUP BY RES1.SUBACCOUNT_CODE' ;
					
				//	pre(beautiful_sql($sql,'<br>', ' &nbsp; &nbsp;'	,false));

					$record=ClxCommon::$db->getOneRecord($sql);
					$IDS='';
					$sum='';
					foreach ($record as $key=>$val) {
						if ($key=='SUMX')
							$sum=$val;
						else {
							if (($pos=strpos($val,',...')<>false))
								$val=substr($val,0,$pos);
							$val=str_replace(',,','',$val);
							$IDS.=$val;
							
						}
						$IDS=trim(str_replace(',,',',',$IDS),',');
					}
					break;
				default:
					$record=ClxCommon::$db->getOneRecord($sql='SELECT GROUP_CONCAT(ID) IDS FROM RCAA_SUBLEDGER_TRANS RCTR WHERE  ID IN('.$idlist_text.') AND ITEM_REF_NO IS NOT NULL AND  RES1.CLX_AUTH_STATUS='.singlequote('AP') );
					
					list($IDS)=$record;
					break;
					
			}
			
			
			$sql='UPDATE RCAA_SUBLEDGER_TRANS RCTR SET ITEM_REF_NO = '.singlequote('ENLZ').' WHERE ID IN('.$idlist_text.') AND ITEM_REF_NO IS NULL AND CLX_AUTH_STATUS='.singlequote('AP');
			ClxCommon::$db->executequery($sql);
			if (!empty($record['IDS'])) {
				$contents.="<br>".smsg('MSG-20191014120225',str_replace(',',' ,',$IDS),$sum); 	
			}
			else {
				$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows);
			}	
		}
		else if ($action=='DELZ') {
			switch (kDatabaseType) {	
				case 'oci':


						$sql='WITH ';
						$extraWhere='';
						$extraTabla1='';
						$extraTabla2='';
						$extraField='';
						$comma='';
						for ($t=1; $t<6;$t++) {
							
							$sql.=$comma.' X'.$t.' AS ( '.
								' SELECT '.singlequote(',').'||LISTAGG(ID,'.singlequote(',').
								' ON OVERFLOW TRUNCATE) WITHIN GROUP (ORDER BY ID) ||'.singlequote(',').' IDS'.$t.
								' FROM RCAA_SUBLEDGER_TRANS RES1'.$extraTabla1.' WHERE '.
										$extraWhere.' RES1.ITEM_REF_NO ='.singlequote('ENLZ').
										' AND  RES1.CLX_AUTH_STATUS='.singlequote('AP') .
										' AND  RES1.ID IN('.$idlist_text.'))';
							$extraTabla1.=', X'.$t;
							$extraTabla2.=' X'.$t.",";
							
							$extraWhere.='INSTR(X'.$t.'.IDS'.$t.','.singlequote(',').'||RES1.ID||'.singlequote(',').')<1 '.(($t<5)? ' AND ': '');
							$extraField.='MIN(X'.$t.'.IDS'.$t.') IDS'.$t.(($t<5)? ', ': '');
							$comma=',';
						}
						$sql.=' SELECT  SUM(TRANS_AMT) SUMX,'.$extraField.
								' FROM '. $extraTabla2. ' RCAA_SUBLEDGER_TRANS RES1 WHERE '	.str_replace(')<1',')<>-1',$extraWhere).
										' AND RES1.ITEM_REF_NO ='.singlequote('ENLZ').
										' AND RES1.ID IN('.$idlist_text.')'.
										' AND  RES1.CLX_AUTH_STATUS='.singlequote('AP').
								'   GROUP BY RES1.SUBACCOUNT_CODE' ;
						
					//	pre(beautiful_sql($sql,'<br>', ' &nbsp; &nbsp;'	,false));

						$record=ClxCommon::$db->getOneRecord($sql);
						$IDS='';
						$sum='';
						foreach ($record as $key=>$val) {
							//ECHO "=========3--==";
							//pre($val);
							if ($key=='SUMX')
								$sum=$val;
							else {
								if (($pos=strpos($val,',...')<>false))
									$val=substr($val,0,$pos);
								$val=str_replace(',,','',$val);
								$IDS.=$val;
								
							}
							$IDS=trim(str_replace(',,',',',$IDS),',');
						}



					$sql='SELECT LISTAGG(ID,'.singleQuote(',').') WITHIN GROUP (ORDER BY ID) IDS FROM RCAA_SUBLEDGER_TRANS RCTR WHERE ID IN('.$idlist_text.') AND NVL(ITEM_REF_NO,'.singlequote('').')<>'.singlequote('ENLZ');
					$record=ClxCommon::$db->getOneRecord($sql);
					break;
				default:
					$record=ClxCommon::$db->getOneRecord($sql='SELECT GROUP_CONCAT(ID) IDS FROM RCAA_SUBLEDGER_TRANS RCTR WHERE  ID IN('.$idlist_text.') AND COALESCE(ITEM_REF_NO,'.singlequote('').')<>'.singlequote('ENLZ') );
			}
			$sql='UPDATE RCAA_SUBLEDGER_TRANS RCTR SET ITEM_REF_NO = NULL WHERE ID IN ('.$idlist_text.') AND ITEM_REF_NO = '.singlequote('ENLZ').' AND  CLX_AUTH_STATUS='.singlequote('AP');
			
			ClxCommon::$db->executequery($sql);
			
			if (!empty($record['IDS'])) {
				$contents.="<br>".smsg('MSG-20191014120225',str_replace(',',' ,',$record['IDS']),$sum); 	
			}
			else {
				$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows);
			}		
		}
		else if  ($action=='ENLZM') {
			switch (kDatabaseType) {	
				case 'oci':
					$sql=' UPDATE ( 
                select  xx.id,RES1.ITEM_REF_NO  FROM RCAA_SUBLEDGER_TRANS XX, RCAA_SUBLEDGER_TRANS RES1
                 WHERE XX.ID='.$idlist_text.' AND  XX.CLX_AUTH_STATUS='.singlequote('AP').'  AND  RES1.ITEM_REF_NO IS NULL AND XX.EFFTDATE=RES1.EFFTDATE
				 AND XX.RCLE_CODE=RES1.RCLE_CODE AND XX.COMP_CODE=RES1.COMP_CODE AND XX.RCTB_CODE=RES1.RCTB_CODE 
						 AND  XX.SUBACCOUNT_CODE=RES1.SUBACCOUNT_CODE  AND XX.CLX_AUTH_STATUS=RES1.CLX_AUTH_STATUS 
						 AND NVL( XX.QUERYCODE,'.singlequote('').')  =NVL( RES1.QUERYCODE,'.singlequote('').') 
						AND RES1.TRANS_AMT<>0
						AND RES1.RECON_ITEM=1
				)  SET ITEM_REF_NO='.singlequote('ENLZ');
         
				
				ClxCommon::$db->executequery($sql);
				
					break;
				default:
					$record=ClxCommon::$db->getOneRecord($sql='SELECT GROUP_CONCAT(ID) IDS FROM RCAA_SUBLEDGER_TRANS RCTR WHERE  ID IN('.$idlist_text.') AND ITEM_REF_NO IS NOT NULL AND  CLX_AUTH_STATUS='.singlequote('AP') );
					
					list($IDS)=$record;
					
					$SI=TRUE;
					if (!EMPTY($IDS) ) {
						$sql='UPDATE RCAA_SUBLEDGER_TRANS RCTR SET ITEM_REF_NO = '.singlequote('ENLZ').' WHERE ID IN('.$IDS.') AND ITEM_REF_NO IS NULL AND CLX_AUTH_STATUS='.singlequote('AP');
						ClxCommon::$db->executequery($sql);
					
						if (!empty($record['IDS'])) {
							$SI=FALSE;
							$contents.="<br>".smsg('MSG-20191014120225',str_replace(',',' ,',$IDS),$sum); 	
							
						}
						
					}	
				
					
					break;
					
				}
				$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows).$this->build_rctr_jump_action('CALC');
				

			}
		else if ($action=='DESLZM') {
			
			switch (kDatabaseType) {	
				case 'oci':
					$sql=' UPDATE ( 
                select  xx.id,RES1.ITEM_REF_NO  FROM RCAA_SUBLEDGER_TRANS XX, RCAA_SUBLEDGER_TRANS RES1
                 WHERE XX.ID='.$idlist_text.' AND  XX.CLX_AUTH_STATUS='.singlequote('AP').'  AND  RES1.ITEM_REF_NO IS NOT NULL AND XX.EFFTDATE=RES1.EFFTDATE
				 AND XX.RCLE_CODE=RES1.RCLE_CODE AND XX.COMP_CODE=RES1.COMP_CODE AND XX.RCTB_CODE=RES1.RCTB_CODE 
						 AND  XX.SUBACCOUNT_CODE=RES1.SUBACCOUNT_CODE  AND XX.CLX_AUTH_STATUS=RES1.CLX_AUTH_STATUS 
						 AND NVL( XX.QUERYCODE,'.singlequote('').')  =NVL( RES1.QUERYCODE,'.singlequote('').') 
						AND RES1.TRANS_AMT<>0
						AND RES1.RECON_ITEM=1
				)  SET ITEM_REF_NO=NULL';
         
				ClxCommon::$db->executequery($sql);
				
					break;
				default:
					$record=ClxCommon::$db->getOneRecord($sql='SELECT GROUP_CONCAT(ID) IDS FROM RCAA_SUBLEDGER_TRANS RCTR WHERE  ID IN('.$idlist_text.') AND ITEM_REF_NO IS NOT NULL  AND CLX_AUTH_STATUS='.singlequote('AP') );
					
					list($IDS)=$record;
					
					$SI=TRUE;
					if (!EMPTY($IDS) ) {
						$sql='UPDATE RCAA_SUBLEDGER_TRANS RCTR SET ITEM_REF_NO = '.singlequote('ENLZ').' WHERE ID IN('.$IDS.') AND ITEM_REF_NO IS NULL AND CLX_AUTH_STATUS='.singlequote('AP');
						ClxCommon::$db->executequery($sql);
					
						if (!empty($record['IDS'])) {
							$SI=FALSE;
							$contents.="<br>".smsg('MSG-20191014120225',str_replace(',',' ,',$IDS),$sum); 	
							
						}
						
					}	
				
					
					break;
					
				}
				$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows);
		}
		
		else if ($action=='CALC') {
			switch (kDatabaseType) {	
				case 'oci':
					$sql='WITH XX AS (select QUERYCODE,CLX_AUTH_STATUS, EFFTDATE, RCLE_CODE, COMP_CODE,RCTB_CODE,SUBACCOUNT_CODE from RCAA_SUBLEDGER_TRANS RES1 WHERE ID='.$idlist_text.' AND  RES1.CLX_AUTH_STATUS='.singlequote('AP').')';
					
					$sql.=' SELECT SUM(TRANS_AMT) SUMX,COUNT(1) CUENTAX '.
							' FROM RCAA_SUBLEDGER_TRANS RES1,XX WHERE '.
							' ITEM_REF_NO = '.singlequote('ENLZ').
							' AND XX.EFFTDATE=RES1.EFFTDATE AND XX.RCLE_CODE=RES1.RCLE_CODE AND '.
							' XX.COMP_CODE=RES1.COMP_CODE AND XX.RCTB_CODE=RES1.RCTB_CODE AND '.
							' XX.SUBACCOUNT_CODE=RES1.SUBACCOUNT_CODE AND XX.CLX_AUTH_STATUS=RES1.CLX_AUTH_STATUS'.
							' AND NVL(XX.QUERYCODE,'.singlequote('').')=NVL(RES1.QUERYCODE,'.singlequote('').')';
		
					$record=ClxCommon::$db->getOneRecord($sql);		
				//	pre(beautiful_sql($sql));
					break;
				default:
					$sql=' (select CLX_AUTH_STATUS, EFFTDATE, RCLE_CODE, COMP_CODE,RCTB_CODE,SUBACCOUNT_CODE from RCAA_SUBLEDGER_TRANS RES1 WHERE ID='.$idlist_text.') AS XX';
					
					$sql=' SELECT SUM(TRANS_AMT) SUMX,COUNT(1) CUENTAX '.
							' FROM RCAA_SUBLEDGER_TRANS RES1,'.$sql.' WHERE '.
							' XX.EFFTDATE=RES1.EFFTDATE AND XX.RCLE_CODE=RES1.RCLE_CODE AND '.
							' XX.COMP_CODE=RES1.COMP_CODE AND XX.RCTB_CODE=RES1.RCTB_CODE AND '.
							' XX.SUBACCOUNT_CODE=RES1.SUBACCOUNT_CODE AND XX.CLX_AUTH_STATUS=RES1.CLX_AUTH_STATUS';
					
					$record=ClxCommon::$db->getOneRecord($sql);		
					break;
					
			}
			if (is_null ($record['SUMX']))
				$record['SUMX']=0;
			$contents .= dict(GEN_SUM_VALUE,$record['SUMX'],$record['CUENTAX']);
			//$contents .= dict(GEN_SUM_VALUE,$record['SUMX'],$record['CUENTAX']);
		
			
		}	
		else if ($action=='PROC') { 
			/*  Codigo 
1. validar que sume zero y generar mensaje
2. Generar nuevo no de referencia
3. Actualizar las transacciones con nuevo no de referencia
4. Mover registros fuentes al histórico
*/
			$retornar='';
			$sql='SELECT ITEM_REF_NO FROM RCAA_SUBLEDGER_TRANS WHERE ID ='.singleQuote($idlist_text);
			$ref=ClxCommon::$db->getOne($sql);
			$newref='';
			IF ($ref<>'ENLZ') {
				$contents .= smsg('MSG-20191011171709');
			//	echo "---$contents---";
			}
			else {
				switch (kDatabaseType) {	
					case 'oci':
					//	$sql='SELECT SUM(TRANS_AMT) SUMX,RES1.SUBACCOUNT_CODE,LISTAGG(ID,'.singleQuote(',').')  WITHIN GROUP (ORDER BY ITEM_REF_NO) X FROM RCAA_SUBLEDGER_TRANS RES1  '.
					//			' WHERE  RES1.ID ='.singleQuote($idlist_text) .' AND RES1.ITEM_REF_NO='.singlequote('ENLZ').' AND EXISTS (SELECT 1 FROM RCAA_SUBLEDGER_TRANS RES2 WHERE RES1.EFFTDATE=RES2.EFFTDATE AND RES1.SUBACCOUNT_CODE	= RES2.SUBACCOUNT_CODE AND RES2.ID='.singleQuote($idlist_text).') GROUP BY RES1.SUBACCOUNT_CODE,floor(RES1.ID/200)' ;
						$sql='SELECT SUM(TRANS_AMT) SUMX,RES1.SUBACCOUNT_CODE,LISTAGG(ID,'.singleQuote(',').')  WITHIN GROUP (ORDER BY ITEM_REF_NO) X FROM RCAA_SUBLEDGER_TRANS RES1  '.
								' WHERE RES1.CLX_AUTH_STATUS='.singlequote('AP'). ' AND '.
       							'	RES1.ITEM_REF_NO='.singlequote('ENLZ').' AND EXISTS (SELECT 1 FROM RCAA_SUBLEDGER_TRANS RES2 WHERE RES1.EFFTDATE=RES2.EFFTDATE AND RES1.SUBACCOUNT_CODE	= RES2.SUBACCOUNT_CODE AND RES2.ID='.singleQuote($idlist_text).') GROUP BY RES1.SUBACCOUNT_CODE,floor(RES1.ID/200)' ;
					

						break;
					default:
						$sql='SELECT SUM(TRANS_AMT) SUMX,GROUP_CONCAT(ID) FROM RCAA_SUBLEDGER_TRANS RES1  '.
							' WHERE  RES1.ID ='.singleQuote($idlist_text) . ' AND  RES1.CLX_AUTH_STATUS='.singlequote('AP') .
							' AND RES1.ITEM_REF_NO='.singlequote('ENLZ').' AND EXISTS (SELECT 1 FROM RCAA_SUBLEDGER_TRANS RES2 WHERE RES1.EFFTDATE=RES2.EFFTDATE AND RES1.SUBACCOUNT_CODE= RES2.SUBACCOUNT_CODE AND RES2.ID='.singleQuote($idlist_text).') GROUP BY RES1.SUBACCOUNT_CODE' ;
					//	ec ho $sql;
				}
				// $sql,"<br>";
				
				$result=ClxCommon::$db->executeQuery($sql);
				$IDS='';
				$sum=0;
				$comma='';
				while ($record = ClxCommon::$db->getNextRecord($result, NUMERIC)) {
					list($suma,$sub_account_code,$id)=$record;
				
					$sum+=$suma;
					$IDS.=$comma.$id;
					$comma=',';
					if ( $this->debug==true) {
						echo "suma a verificando:",$sum, " sumado: ",$suma,"<br>";

					}
			
				}
				if ( $this->debug==true) {
					echo "suma a verificar total:",$sum,"<br>";

				}
				//list($sum,$IDS)=array_values($record);
				switch (kDatabaseType) {
					case 'oci':
						$sql='SELECT TO_NUMBER(SUBSTR(NVL(MAX(ITEM_REF_NO),'.SINGLEQUOTE('000000000').'),-7)) GRP   FROM RCAA_SUBLEDGER_TRANS WHERE ITEM_REF_NO <> '.singlequote('ENLZ');// WHERE FORMCODE='.singlequote($record['UIFL_formcode']);
						break;
					default:
						$sql='SELECT CONVERT(RIGHT(MAX(ITEM_REF_NO),7),UNSIGNED INTEGER) GRP FROM RCAA_SUBLEDGER_TRANS WHERE ITEM_REF_NO <> '.singlequote('ENLZ');// WHERE FORMCODE='.singlequote($record['UIFL_formcode']);
				 }
				$newref=ClxCommon::$db->getOne($sql) ;
				$newref=SUBSTR('0000000'. ($newref+1),-7);
				//ec ho $sum;
				if ( $this->debug==true) {
					echo "suma a verificar total con floatval:",floatval($sum),"<br>";
					echo "suma id:",$newref,"<br>";
				}
				if (round(floatval($sum),2,PHP_ROUND_HALF_DOWN) ==0) {
					$sql='UPDATE RCAA_SUBLEDGER_TRANS  SET ITEM_REF_NO = '.singlequote($newref).
					' WHERE ITEM_REF_NO='.singlequote('ENLZ'). ' AND CLX_AUTH_STATUS='.singlequote('AP').
					' AND EXISTS ('.   //singlequote(str_replace(",",singlequote(','),$IDS)).
					'       SELECT 1 FROM RCAA_SUBLEDGER_TRANS RES1 WHERE RES1.EFFTDATE=RCAA_SUBLEDGER_TRANS.EFFTDATE AND '.
					'       RES1.SUBACCOUNT_CODE= RCAA_SUBLEDGER_TRANS.SUBACCOUNT_CODE AND RES1.ID='.singleQuote($idlist_text)
					.')';
					ClxCommon::$db->executequery($sql);
				//	echo $sql;
					$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows); // . '<br>' . $this->displayMsg;
				}
				else {
					 $contents .= smsg('MSG-20191011153733'); // . '<br>' . $this->displayMsg;
				}
				$contents.=$this->move_registers($newref);
			}
		}
		return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
	}
	
	function move_registers($newref=''){
		$retorno='';
		switch (kDatabaseType) {
            case 'oci':
				$sql0=' SELECT X.TABLE_CODE,X.TABLE_CODE_HIST, (SELECT CONCAT(MODULECODE,CONCAT('.singleQuote('_').',IDNAME)) FROM CLX_DB_TABLES WHERE TABLE_CODE=IDCODE AND ROWNUM<=1 ) TABLE_NAME,(SELECT CONCAT(MODULECODE,CONCAT('.singleQuote('_').',IDNAME)) TABLE_NAME_HIST FROM CLX_DB_TABLES WHERE TABLE_CODE_HIST=IDCODE AND ROWNUM<=1 ) TABLE_NAME_HIST FROM CLX_DB_TABLE_HIST X ';
				break;	
			default:
			     $sql0=' SELECT X.TABLE_CODE,X.TABLE_CODE_HIST, (SELECT CONCAT(MODULECODE,CONCAT('.singleQuote('_').',IDNAME)) FROM CLX_DB_TABLES WHERE TABLE_CODE=IDCODE LIMIT 1 ) TABLE_NAME,(SELECT CONCAT(MODULECODE,CONCAT('.singleQuote('_').',IDNAME)) TABLE_NAME_HIST FROM CLX_DB_TABLES WHERE TABLE_CODE_HIST=IDCODE LIMIT 1 ) TABLE_NAME_HIST FROM CLX_DB_TABLE_HIST X ';
		}
//PRE($sql0);		
		$table_hist=array();
		$rs = ClxCommon::$db->executeQuery($sql0);
		
		if ( $this->debug==true) {
				echo "sql0:",$sql0,"<br>";
				
			}
		while ($tables = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$table_hist[$tables['TABLE_NAME']]=ARRAY($tables['TABLE_NAME_HIST'],$tables['TABLE_CODE'],$tables['TABLE_CODE_HIST']);
		}
		//PRE($table_hist);
		
		$xxtables=array();
		if (empty($newref)) {
			$xxtables[0]=ClxCommon::$db->getOneRecord($sqlx='select TABLECODE,TABLECODE2 from RCAA_SUBLEDGER_TRANS WHERE ID='.$idlist[0]); 
		
		}
		else {

			$rsx=ClxCommon::$db->executequery ($sqlx='select distinct TABLECODE,TABLECODE2 from RCAA_SUBLEDGER_TRANS WHERE   ITEM_REF_NO='.singlequote($newref)); 
			while ($xx= ClxCommon::$db->getNextRecord($rsx, ASSOCIATIVE)) {
				if(empty($xx['TABLECODE']) AND empty($xx['TABLECODE2'])){
				}
				else {
					$xxtables[]=$xx;
				}
			}
	//		PRE($xxtables);
		}
			if ( $this->debug==true) {
				echo "sqlx:",$sqlx,"<br>";
				
			}

		
		foreach ($xxtables as $key=>$xtables) { 
		
			/*$sql1='SELECT DISTINCT DBTB.IDCODE TABLECODE, CONCAT(DBTB.MODULECODE,CONCAT('.singleQUote('_').',DBTB.IDNAME)) TABLENAME FROM CLX_DB_TABLES DBTB, 
			RCAA_SUBLEDGER_TRANS RCAA WHERE DBTB.IDCODE=RCAA.TABLECODE AND RCAA.TABLECODE='.SINGLEQUOTE($xtables['TABLECODE']).'
				UNION
				SELECT DISTINCT DBTB.IDCODE TABLECODE, CONCAT(DBTB.MODULECODE,CONCAT('.singleQUote('_').',DBTB.IDNAME)) TABLENAME FROM CLX_DB_TABLES DBTB, 
			RCAA_SUBLEDGER_TRANS RCAA WHERE DBTB.IDCODE=RCAA.TABLECODE2 AND RCAA.TABLECODE2='.SINGLEQUOTE($xtables['TABLECODE2']);
			*/
			$sql1='SELECT DISTINCT DBTB.IDCODE TABLECODE, CONCAT(DBTB.MODULECODE,CONCAT('.singleQUote('_').',DBTB.IDNAME)) TABLENAME FROM RCAA_RECON_DATASRC A,CLX_DB_QUERIES B,CLX_DB_QUERY_TABLES C,CLX_DB_TABLES DBTB WHERE A.QUERYCODE=B.IDCODE 
					AND A.QUERYCODE=C.QUERYCODE AND C.TABLECODE=DBTB.IDCODE  AND C.TABLECODE='.SINGLEQUOTE($xtables['TABLECODE']);
			
			$rs = ClxCommon::$db->executeQuery($sql1);

			if ( $this->debug==true) {
				echo "sql:",$sql1,"<br>";
				
			}
			while ($tablescode = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {//pre($tablescode);
				if ( $this->debug==true) {
					echo "tablescode:";
					pre($tablescode);
					echo "tablescode from table_hist:";
					pre($table_hist[$tablescode['TABLENAME']]);
				}
				$FIELSD1='';
				$FIELSD2='';
				$sql='SELECT A.FIELDNAME FROM CLX_DB_TABLEFIELDS A, CLX_DB_TABLEFIELDS B WHERE A.TABLECODE='.singlequote($tablescode['TABLECODE']).' AND B.TABLECODE='.singleQUote($table_hist[$tablescode['TABLENAME']][2]).' AND A.FIELDNAME=B.FIELDNAME';
				if ( $this->debug==true) {
					echo "sql2:",$sql,"<br>";
					
				}
				$rsY =ClxCommon::$db->executequery($sql);
				$FIELSD1='';
				$FIELSD2='';
				$separ='';
				
				while ($resultY = ClxCommon::$db->getNextRecord($rsY, ASSOCIATIVE)) {//echo 'xxxxxxxxxxxx';
					$FIELSD1.=$separ.$resultY['FIELDNAME'];
					$FIELSD2.=$separ.'A.'.$resultY['FIELDNAME'];
					$separ=',';
				}
				if ( $this->debug==true) {
					echo "fields1:";
					pre($FIELSD1);
					echo "fields2:";
					pre($FIELSD2);
					
				}
				if(empty($FIELSD1) || empty($FIELSD2)) { echo "aca"; 
					$retorno.=dict('GEN_LBL_NOT_HISTORIC_NOT_FOUND').' '.$tablescode['TABLENAME'].'<BR>';
					CONTINUE;
				}
				
				$sql='INSERT INTO '.$table_hist[$tablescode['TABLENAME']][0]. '  ('.$FIELSD1.') '.
							 ' SELECT ' .$FIELSD2. ' FROM '.$tablescode['TABLENAME']. ' A  
							 WHERE 
								NOT EXISTS(
									SELECT 1 FROM '.$table_hist[$tablescode['TABLENAME']][0]. ' Y WHERE A.ID=Y.ID )
							  
							  AND EXISTS (
								SELECT 1 FROM RCAA_SUBLEDGER_TRANS X WHERE  ITEM_REF_NO<>'.singlequote('ENLZ').' AND
								(X.REC_ID=A.ID AND X.TABLECODE='.singleQuote($tablescode['TABLECODE']).  ' )
								UNION
								SELECT 1 FROM RCAA_SUBLEDGER_TRANS X WHERE ITEM_REF_NO<>'.singlequote('ENLZ').' AND
								 (X.REC_ID2=A.ID AND X.TABLECODE2='.singleQuote($tablescode['TABLECODE']). '))';
				if ( $this->debug==true) {
					echo "sql3", $sql,"<br>";
				
				}
				ClxCommon::$db->executequery($sql);
				
				//$a=fopen(kPathToWebSite.'temp/salida3x.txt','a+');fwrite($a,$sql.chr(13).chr(10));fclose($a) ;


				///========================================================================
				
				


				$sql='DELETE FROM '.$tablescode['TABLENAME']. ' WHERE EXISTS(SELECT 1 FROM '.$table_hist[$tablescode['TABLENAME']][0].' X WHERE  X.ID='.$tablescode['TABLENAME'].'.ID)';
				ClxCommon::$db->executequery($sql);
				ClxCommon::$db->executequery('COMMIT');
			}
		}
		return ((empty($retorno))?'': '<br>'.$retorno);
		
	}
	/*
	function rcjh_validate_form($record, &$msg){
		$idlist = getIdlist();
		$contents='';
		IF ($record['RCJH_EFFTDATE'] >$record['RCJH_REAL_DATE']) {
			$msg['RCJH_EFFTDATE']=dict('FE_ME_FE_REAL');
		}
		if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' ) {
			$rcjh_res=ClxCommon::$db->getOneRecord($sql='SELECT CASE WHEN SUM(COALESCE(DEBIT_AMT,0)) - SUM(COALESCE(CREDIT_AMT,0)) =0 THEN 0 ELSE 1 END DIFERENCIA FROM RCAA_JOURNAL_HDR RCJH,RCAA_JOURNAL_LINES X WHERE X.RCJH_CODE=RCJH.IDCODE AND RCJH.ID='.$idlist[0]);
		//	ECHO $sql;		
			if 	($rcjh_res['DIFERENCIA']==1) {
				$contents=$msg['RCJL_DEBIT_AMT']=dict('mount_cre_deb_0');
						
				return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
			}
		}
		
	}*/
	function rcjh_validate_form($record, &$msg){
		//pre($record);	
		//pre(UserRequest::$request);
		//pre($msg);
		//pre($GLOBALS);
		//$idlist = implode(",",$idli=getIdlist());
		//if (empty($idlist))
		//	return false;
		//for ($t=0;$t<count($idli);$t++) {
		//	unset (UserRequest::$request['selector_'.$idli[$t]]);
		//	unset (UserRequest::$post['selector_'.$idli[$t]]);
		//}
		$contents=''; 
		IF ($record['RCJH_EFFTDATE'] >$record['RCJH_REAL_DATE']) {
			$msg['RCJH_EFFTDATE']=dict('FE_ME_FE_REAL');
		}
		
		
		if (UserRequest::$request['ac'] === 'DELETE') {
			if (empty($record['idlist']) && isset(UserRequest::$request['idlist'])) {
				$record['idlist']=UserRequest::$request['idlist'];
			}
			$sql='SELECT RCJH.CLX_AUTH_STATUS,IDCODE FROM RCAA_JOURNAL_HDR RCJH WHERE RCJH.ID ='.$record['idlist'];		
			$rs=ClxCommon::$db->executequery($sql);
			$record2= ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE);
			UserRequest::$request['RCJH_IDCODE']=$record2['IDCODE'];
			$CLX_AUTH_STATUS=$record2['CLX_AUTH_STATUS'];
			
			if ($CLX_AUTH_STATUS==='AP'){
				$msg['RCJL_RCJH_CODE']=dict('CODE_ERR_INVALID_STATUS_JOURNAL',UserRequest::$request['RCJH_IDCODE']);
				addmessage($msg['RCJL_RCJH_CODE']);
				return false;
			}
		
		}	
		
		else if ($record['RCJH_CLX_AUTH_STATUS']=='AP' ) {
			$msg['RCJH_CLX_AUTH_STATUS']=dict('CODE_ERR_INVALID_STATUS');
		}
		if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' ) {
			$rs=ClxCommon::$db->executequery($sql='SELECT IDCODE, CASE WHEN SUM(COALESCE(DEBIT_AMT,0)) - SUM(COALESCE(CREDIT_AMT,0)) =0 THEN 0 ELSE 1 END DIFERENCIA,COUNT(1)CUENTA FROM RCAA_JOURNAL_HDR RCJH,RCAA_JOURNAL_LINES X WHERE X.RCJH_CODE=RCJH.IDCODE AND RCJH.IDCODE= '.singlequote($record['RCJH_IDCODE']).' GROUP BY RCJH.IDCODE ');
			$truecount=0;
			if ($rcjh_res = ClxCommon::$db->getNextRecord($rs)) {
				$truecount=$rcjh_res['CUENTA'];
				if 	($rcjh_res['DIFERENCIA']==1) {
					$contents=$msg['RCJL_DEBIT_AMT']=dict('mount_cre_deb_0',$rcjh_res['IDCODE']);
					return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
				}
				
				
			}	
			if ($truecount<2) {
				$contents=$msg['RCJH_IDCODE']=dict('JOURNAL_LINES_NOT_FOUND',$record['RCJH_IDCODE']);
				return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
				
			}
		}
		
	}
	
	
	function rcjl_validate_form($record, &$msg){
		
		$CLX_AUTH_STATUS='';
		if (UserRequest::$request['ac'] === 'DELETE') {
			if (empty($record['idlist']) && isset(UserRequest::$request['idlist'])) {
				$record['idlist']=UserRequest::$request['idlist'];
			}
			$sql='SELECT RCJH.IDCODE ,RCJH.CLX_AUTH_STATUS FROM RCAA_JOURNAL_HDR RCJH,RCAA_JOURNAL_LINES RCJL WHERE RCJL.RCJH_CODE=RCJH.IDCODE AND RCJL.ID ='.$record['idlist'];		
			$rs=ClxCommon::$db->executequery($sql);
			$record2= ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE);
			UserRequest::$request['RCJL_RCJH_CODE']=$record2['IDCODE'];
			$CLX_AUTH_STATUS=$record2['CLX_AUTH_STATUS'];
			
			
		}
		if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'MODIFY'|| UserRequest::$request['ac'] === 'DUPLICATE') {
			$sql='SELECT RCJH.CLX_AUTH_STATUS FROM RCAA_JOURNAL_HDR RCJH WHERE RCJH.IDCODE= '.singlequote(UserRequest::$request['RCJL_RCJH_CODE']);
			$CLX_AUTH_STATUS=ClxCommon::$db->getOne($sql);
		}	
		if ($CLX_AUTH_STATUS==='AP'){
			if (UserRequest::$request['ac'] === 'DELETE') {
				$msg['RCJL_RCJH_CODE']=dict('CODE_ERR_INVALID_STATUS_JOURNAL',UserRequest::$request['RCJL_RCJH_CODE']);
				addmessage($msg['RCJL_RCJH_CODE']);
			
				return false;
			}
			else {
				$msg['RCJL_RCJH_CODE']=dict('CODE_ERR_INVALID_STATUS_JOURNAL',"");
				$contents=dict('CODE_ERR_INVALID_STATUS_JOURNAL',UserRequest::$request['RCJL_RCJH_CODE']);
				return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
			}
			
		}	
			
	
	}
	function rctr_view_item_is_approved_or_auth($record) {
		// VALIDACION PARA ITEMS VERIFICAR PRIMERO SI PASA DIRECTO O PASO POR AUTORIZACIONES
		// Search Account Max Authorized Amount en el catalogo de cuentas.
		$sql='SELECT RCAC.MAX_AUTH_AMT FROM RCAA_CODES_TBL RCAC WHERE RCAC.IDCODE =' . singlequote($record['SUBACCOUNT_CODE']);
		$MAX_AUTH_AMT=ClxCommon::$db->getOne($sql);
		//pre($record);
		//pre
		//(
		
		$nochange=ClxCommon::$db->getOne($sq='SELECT COUNT(1) FROM RCAA_SUBLEDGER_TRANS '.
					' WHERE RCMAX_DT '. (is_null($record['RCMAX_DT'])|| $record['RCMAX_DT']=='null' ? ' IS NULL ': '= '.singleQuote( $record['RCMAX_DT'])).
					' AND CASE WHEN BENCHMARK_DAYS IS NULL OR BENCHMARK_DAYS=0 THEN '.
					'	(select  BENCHMARK_DAYS from RCAA_CODES_TBL X where X.idcode='.
					singlequote($record['SUBACCOUNT_CODE']).' AND X.RCAG_CODE='.
					singlequote($record['COMP_CODE']).') ELSE BENCHMARK_DAYS END = '. $record['BENCHMARK_DAYS']. 
					' AND  ID='.Userrequest::$request['RCTR_ID'] );
			//pre($sq);
		$authpend=ClxCommon::$db->getOne('SELECT COUNT(1) FROM CLX_AC_AUTHORIZATIONS WHERE AUTH_STATUS='.SINGLEQUOTE('PEND').' AND TABLECODE='.SINGLEQUOTE('RCTR').' AND REC_ID ='.Userrequest::$request['RCTR_ID']);
		/*echo 'a:',$nochange,'<br>';
		pre($sq);
		pre( $record['RECON_ITEM']);
		pre($nochange);
		pre($record['REC_SRC']);
		pre( abs($record['TRANS_AMT']));
		pre(abs($MAX_AUTH_AMT) );
		echo "'".$authpend."'";*/
		return  ($authpend == 0 && $record['RECON_ITEM']==1 &&$nochange==1&& /*$record['REC_SRC']=='ON' && */ abs($record['TRANS_AMT']) <= abs($MAX_AUTH_AMT) ) ;
	}

	function rctr_validate_form(&$record, &$msg){
		$contents=''; 
		//pre($record);
	//	if ($record['RCTR_CLX_AUTH_STATUS']==='AP'){
	//			$msg['RCTR_CLX_AUTH_STATUS']=dict('CODE_ERR_INVALID_STATUS_RCTR');
	//	}

		// VALIDACION PARA ITEMS DE CONCILIACION CONTRA EL MONTO MAXIMO AUTORIZADO POR CUENTA CONTABLE
		
		// Search Account Max Authorized Amount en el catalogo de cuentas.
		/*	$sql='SELECT RCAC.MAX_AUTH_AMT FROM RCAA_CODES_TBL RCAC WHERE RCAC.IDCODE =' . singlequote($record['RCTR_SUBACCOUNT_CODE']);
		$MAX_AUTH_AMT=ClxCommon::$db->getOne($sql);

		if ($record['RCTR_RECON_ITEM']==1 && $record['RCTR_REC_SRC']=='ON' && abs($record['RCTR_TRANS_AMT']) > abs($MAX_AUTH_AMT) ) {
				$msg['RCTR_TRANS_AMT']=dict('CODE_ERR_ITEM_GT_MAX_AMT', $MAX_AUTH_AMT);
		}*/
/*		else { 
			$record['CLX_AUTH_STATUS']= 'AP';
		}
*/		
	}
	
	function rctr_approve_item(&$record, &$msg){
		$contents=''; 
		// VALIDACION PARA ITEMS DE CONCILIACION CONTRA EL MONTO MAXIMO AUTORIZADO POR CUENTA CONTABLE
		
		// Search Account Max Authorized Amount en el catalogo de cuentas.
		$sql='SELECT RCAC.MAX_AUTH_AMT FROM RCAA_CODES_TBL RCAC WHERE RCAC.IDCODE =' . singlequote($record['SUBACCOUNT_CODE']);
		$MAX_AUTH_AMT=ClxCommon::$db->getOne($sql);

		if ($record['RECON_ITEM']==1 && $record['REC_SRC']=='ON' && abs($record['TRANS_AMT']) <= abs($MAX_AUTH_AMT) ) {
			$record['CLX_AUTH_STATUS']= 'AP';
		}
	}

}


