<?php

/**
 * File to be run by cron Scheduler Each Minute
 */
if (!defined('__DIR__')) {
    define('__DIR__', dirname(__FILE__));
}
set_include_path(str_replace('\\', DIRECTORY_SEPARATOR, __DIR__) . DIRECTORY_SEPARATOR . PATH_SEPARATOR . get_include_path());
require_once '/includes/constants_xpengine.php';
require_once kPathToWebSite . '/includes/includes.php';
$db = null;
PrepareConstants();
ConnectToDatabase();
initToolsCron();
if ($argc > CLX_NUM_ONE) {
    // Specifying DBIM or DBEX
	$list_file = (isset($argv[CLX_NUM_TWO]) ? $argv[CLX_NUM_TWO] : null);
	switch ($argv[CLX_NUM_ONE]) {
		case 'DBIM':
			if(is_null($list_file)) {
				$list_file = 'import_list.txt';
			}
			$DBIM = &getTool('DBIM');
			$DBIM->import_from_list($list_file);
			break;
		case 'DBEX':
			$DBEX = &getTool('DBEX');
			$DBEX->export_from_list($list_file);
			break;
		default:
	        print 'ERROR-Invalid Tool Code: '.$argv[CLX_NUM_ONE];
    }
} else {
	$DBIM = &getTool('DBIM');
	$DBIM->import_from_list();
}
