// JavaScript Document
function updateDBLT(fieldname, targetfields) {
    var target_field = '';
    var selected_val = '';
    var fieldobj = $('#' + fieldname);
    if (targetfields.length > 0) {
        $.each(targetfields.split(','), function (key, val) {
            if (key == 0) {
                target_field = val;
                selected_val = $('#' + val).val();

            }
            if ($('#' + val).attr('type') != undefined && $('#' + val).attr('type').indexOf('select') > -1) {
                $('#' + val).html('<option></option>');
            }
        });
    } else {
        target_field = fieldname;
        selected_val = fieldobj.val();
    }
    var url = 'window.php?to=UIFM&ac=LIST_AJAX&no_menu=1&no_alerts=1';
    url += '&fl=' + fieldname + '&sfl=' + targetfields + '&it=' + fieldobj.val();
    $.getJSON(url,
            function (data) {
                var options = '';
                $.each(data, function (key, val) {
                    options += '<option value="' + key + '"';
                    if (selected_val == key) {
                        options += ' selected';
                    }
                    options += '>' + val + '</option>';
                });
                $('#' + target_field).html(options);
            }
    );
}//end function


function DBLT_load_list_enties(form_fieldname) {

    //no need for list
    if ($('#' + form_fieldname).attr('clxlock') == undefined) {
        return;
    }
    var curval = $('#' + form_fieldname).val();
    var parentitem = $('#' + form_fieldname).attr('clxprnt');
    var parentitemval = '';
    if (parentitem == undefined) {
        parentitem = '';
    }
    if (parentitem != '') {
        parentitemval = $('#' + parentitem).val();
    } else {
        parentitemval = '';
    }

    $.ajax({
        url: 'window.php?to=UIFM&ac=LIST_AJAX&no_menu=1&no_alerts=1&fl=' + form_fieldname + '&sfl=' + form_fieldname + '&it=' + parentitemval,
        async: false,
        dataType: 'json',
        beforeSend: function (xhr) {/*showWait();*/
        },
        success: function (data) {
            $('#' + form_fieldname).empty();
            $.each(data, function (key, val) {
                $('#' + form_fieldname).append($('<option></option>').attr('value', val.key).text(val.val));
            });
            $('#' + form_fieldname).val(curval);
        }
    }).fail(function (jqXHR) {
		alert('DBLT_ajax fail:' + jqXHR.statusText + ' ' + jqXHR.status);
    }).always(function () {/*hideWait();*/
    });
}

function DBLT_over() {
    var self = this;
    if ($(self).attr('clxlock') == 1) {
        return;
    }
    $(self).attr('clxlock', 1);
    DBLT_load_list_enties($(self).attr('id'));
}
function DBLT_out() {
    return;
}

function DBTL_set_evnt(uiff, form_fieldname) {

    $('#' + form_fieldname).hoverIntent({over: DBLT_over, timeout: 1000, out: DBLT_out});
    //change
    $('#' + form_fieldname).change(function () {
        var self = this;
        DBLT_load_list_change_item($(self).attr('id'));
    });
}


function DBLT_load_list_change_item(form_fieldname) {

    $(':input[clxprnt="' + $('#' + form_fieldname).attr('id') + '"]').each(function () {
        var self = this;
        $(self).empty();
        $(self).attr('clxlock', 0);
        DBLT_load_list_change_item($(self).attr('id'));
    });
}

function DBLT_set_on_change(form_fieldname) {
    $('#' + form_fieldname).change(function () {
        DBLT_load_list_change_item(form_fieldname)
    });
}