<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-29 14:15:35 -0400 (Mon, 29 Oct 2018) $
 * @version        $Rev: 10297 $
 * @package		Clientix.Classes.File
 * @abstract	General Class
 *
 * CHANGE LOG
 *  Included label
 * 	toArray() method added
 */
class clx_file_delimited extends clx_file {

    var $line_delim;
    var $num_records;
    var $field_delim;
    var $buffer;
    var $buffer_size;
    var $loaded_size;
    var $split_record = false;
    var $EOF;

    function __construct($file_name, $line_delim = CLX_CHAR_NL, $field_delim = array(CLX_CHAR_TAB),$is_regular7=false,$read_all=false,$UTF8=false,$replace_comillas=false) {
        parent::__construct($file_name, 'r');
        $this->line_delim = $line_delim;
		$this->file_name=$file_name;
		$this->xx=0; 
        $this->num_records = CLX_INIT_ZERO;
        $this->line_num = CLX_INIT_ZERO;
        $this->field_delim = $field_delim;
        $this->buffer = '';
		$this->ultimolotcorrido=0;
        $this->loaded_size = CLX_INIT_ZERO;
		$this->is_regular7 = $is_regular7;
        $this->EOF = false;
        $this->debug = false;
		$this->UTF8=$UTF8;
		//echo $file_name;die;
		$this->replace_comillas=$replace_comillas;
		$this->max_num_lot=1;
		$record_length=0;
		
		$this->file_read_tonow_bytes=0;
		if ($read_all===true) {
			
			if ($replace_comillas)
				cambiocomillascomas_simple($file_name);
			$this->init_lot=1;
			$this->superlotnum=0;
			
			clearstatcache(true,$file_name);
			$this->file_read_tonow_bytes=0;
			$this->filesize=(int) filesize($file_name);
			if ($this->filesize> 8000000)
				$this->superlotsize= 8000000;
			else
				$this->superlotsize=$this->filesize;
			$this->countsuperlot= (int) ( ($this->filesize/$this->superlotsize)+1);
			
			
			$this->initsuperlot=-$this->superlotsize;
        $this->open();
        if (empty($this->error)) {
            $this->size();
        }
				
			$this->getinformationlot();	
		}
		else {
			$this->buffer_size = (int) (!$record_length) ? CLX_NUM_1024 : $record_length;
			$this->open();
			if (empty($this->error)) {
				$this->size();
			}
    }

    }
    function fill_buffer($UTF8) {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1900;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_clx_file_delimited-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        while ((strpos($this->buffer, $this->line_delim) === false) && ($this->loaded_size < $this->file_size)) {
            $btext = $this->read($this->buffer_size);
			if ($UTF8==true) {
				$btext=utf8_encode($btext);
			}	
            $this->loaded_size += strlen($btext);
			$this->file_read_tonow_bytes+=strlen($btext);
            $this->buffer .= $btext;
            if (!empty($this->debug))
                echoLog('>>>===--- Loaded ' . $this->loaded_size . ' bytes of ' . $this->file_size . '<br>');
        }
    }

    function toArray($s_line) {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1901;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_clx_file_delimited-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		if (count($this->field_delim)==1 and !$this->is_regular7) {
			return explode($this->field_delim[CLX_INIT_ZERO], $s_line);
		}
		else {
			//preg_match_all($this->field_delim, $s_line,PREG_OFFSET_CAPTURE);
			$texto_array = preg_split(implode("|", $this->field_delim), $s_line, PREG_SPLIT_OFFSET_CAPTURE);
			$ret=array();
			foreach ($texto_array as $values) {
				$ret[]=values[1];
			}
			return $ret;
		}	
    }

    function getNextRecord() {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1902;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_clx_file_delimited-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $this->fill_buffer();
        $pos = strpos($this->buffer, $this->line_delim);
        if (false === $pos) {
            $pos = strlen($this->buffer);
            $this->EOF = true;
        }
        $record = substr($this->buffer, CLX_NUM_ZERO, $pos);
        if (substr($record, strlen($record)) == $this->line_delim) {
            $record = substr($record, CLX_NUM_ZERO, strlen($record) - CLX_NUM_ONE);
        }
		$this->file_read_tonow_bytes+=$pos;
        $this->buffer = substr($this->buffer, $pos + CLX_NUM_ONE);
        $this->num_records++;
        $this->line_num++;
        return $record;
    }
    
    function getNextRecord2($UTF8=false) {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1903;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_clx_file_delimited-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $this->fill_buffer($UTF8);
	
        $pos = strpos($this->buffer, $this->line_delim);
	    if (false === $pos) {
            $pos = strlen($this->buffer);
            $this->EOF = true;
        }
        $record = substr($this->buffer, CLX_NUM_ZERO, $pos);
	    if (substr($record, strlen($record)) == $this->line_delim) {
            $record = substr($record, CLX_NUM_ZERO, strlen($record) - CLX_NUM_ONE);
        }
        $this->file_read_tonow_bytes+=$pos;
        
        $this->buffer = substr($this->buffer, $pos +strlen($this->line_delim));
		
        $this->num_records++;
        $this->line_num++;
        return $record;
    }

    function parsetoarray($import,$restrictions=array(),$counter='',$lot=0,$superlotnum=0){
		if ($this->superlotnum<>$superlotnum ){
			$this->superlotnum=$superlotnum;
			$this->getinformationlot();
			
		}
		$buffer=&$this->buffer;
		
		if (!isset($buffer[$lot])) {
			return false;
		}
		$insertfields=&$import->options_import['insertfields'];
		$ignored_records2=&$import->options_import['ignored_records2'];
		
		$line_delim=&$this->line_delim;
		$cdelim=$this->field_delim;//e cho "==============" ,$cdelim;
		$bufferx=explode($line_delim,$buffer[$lot]);
		
		$this->count_record=count($bufferx);
		$ult_line=$bufferx[$this->count_record-1];
		$init_lot=&$this->init_lot; 
		if ($superlotnum+1<$this->countsuperlot || $lot+1<$this->max_num_lot)
			unset($bufferx[$this->count_record-1]);
		if (!empty($buffer[$lot+1]) || !empty($ult_line)) {
			$buffer[$lot+1]=$ult_line.(empty($buffer[$lot+1])?'':$buffer[$lot+1]) ;
			$this->ultimolotcorrido=$lot+1;
		}	
		$this->count_record_lot=count($bufferx);
		
		$max= &$this->count_record_lot;
		$valid=false;
		$nw=0;
		
		if (empty($counter)) {
			for ($r=0;$r<$max;$r++){
				if ($import->apply_Restriction($restrictions,$bufferx[$r],$r+$init_lot)) {
					$ignored_records2++;
					unset($bufferx[$r]);
				}else{
					$bufferx[$r]=explode($cdelim,$bufferx[$r]);
				}	
			}
			$nw=$max;
		}
		else {
			for ($r=0;$r<$max;$r++){
				$nw=$r+$init_lot;
				if ($import->apply_Restriction($restrictions,$bufferx[$r],$r+$init_lot)) {
					unset($bufferx[$r]);
				}else{
					if (!empty($bufferx[$r])) {
						$x=explode($cdelim,$bufferx[$r]);
						$x[$counter]=$nw;
						$bufferx[$r]=$x;
					}
				}	
			}
		}
		if($lot==0&&$superlotnum==0) {
			$this->init_lot=$nw+1;
		}	
		else {
			$this->init_lot=$nw+1;
		}	
		
		$bufferx=array_values($bufferx);

		$this->bufferx=&$bufferx;
		return true;	
	}
	function getinformationlot() {
		$UTF8=&$this->UTF8;
		$ult_line=''; 
		
		if (!empty($this->buffer[$this->max_num_lot])) {
			$ult_line=$this->buffer[$this->max_num_lot];
		}
		$this->file_read_tonow_bytes+=$this->buffer_size;
		$this->buffer_size = $this->superlotsize;
		$this->initsuperlot+=$this->superlotsize;
		
		$this->buffer =$ult_line. ($xx=$this->read($this->buffer_size));
		if ($UTF8===true ) {
			$this->buffer=utf8_encode($this->buffer);
		}
		$this->buffer=''.$this->buffer;
		
		$buffer = str_split($this->buffer,130000);
		$this->max_num_lot=count($buffer);
		$this->buffer=&$buffer;
		$this->ultimolotcorrido=0;

	}
	function getNumrowMax () {  //for bigfile
		$x=fopen($this->file_name,'r');
		$data='';
		$contar=0;
		$line_delim=$this->line_delim;
		$a=microtime(true);
		$max=250000;
		$lnsize=strlen($line_delim);
		while (!feof($x)) {
			$texto=fread($x,$max);
			$data.=$texto;
			$contarx=0;
			$contarx=substr_count($data,$line_delim);
			if ($contarx>0) {
				$contar+=$contarx;
				$pos=strrpos($data,$line_delim);
				
				if ($pos>=0) {
					$posi=-strlen($data)+$pos+$lnsize-1;
					$data=substr($data,$posi);
				}
				else {
				}
			}
			else {
				$data=substr($data,-1);
			}
		}
		fclose($x);
		return $contar+ (filesize($this->file_name)>0)? 1:0;
	}
	
}
