<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: fsantana $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version		$Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Filc {

    var $display = false;

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FIAS', 'FIAE', 'PROD', 'PRAT', 'GLAC', 'AMDS', 'GLT1', 'JEHD', 'JELN', 'FIAT', 'JCBV', 'FILC', 'FILO'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
    }

    /**
     * Update Information one record is saved
     */
    function save_form_post(&$record) {
        //Adjust colateral information if exists
        $sql = 'UPDATE  ' . $this->filcname . ' FILC  SET  FILC.FIAS_LOAN_CODE = (SELECT MAX(FIAS.IDCODE) FROM ' . $this->fiasname . ' FIAS WHERE FIAS.LOAN_CODE =' . singleQuote($record['LOAN_CODE']) . '  ), FILC.FIAS_COLL_CODE = (SELECT MAX(FIAE.CHART_FIELD03) FROM ' . $this->fiaename . ' FIAE WHERE FIAE.IDCODE = FILC.ASSETCODE), FILC.COMP_CODE = (SELECT MAX(FILO.COMP_CODE) FROM ' . $this->filoname . ' FILO WHERE FILO.IDCODE =' . singleQuote($record['LOAN_CODE']) . ' ) WHERE FILC.LOAN_CODE =' . singleQuote($record['LOAN_CODE']) . ' AND FILC.ASSETCODE =' . singleQuote($record['ASSETCODE']);
        ClxCommon::$db->executeQuery($sql);
    }

}
