<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-04-20 08:37:18 -0400 (Fri, 20 Apr 2018) $
 * @version        $Rev: 9795 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Rcaa {
    
    function Rcaa($procParameters = array()) {
		$tta=fopen(kPathToWebSite."/".kPathToTemp."archivorcta2.txt","a+");
		fclose($tta);
        multiTableName($this, array('RCTA'));
       // $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
    }

    /**
     * Action from jump listing
     */
    public function build_rcjh_jump_action($action='') {
		
		$contents = '';
        $idlist = getIdlist();
		$idlist_text = implode(",",$idlist);
        if (empty($idlist))
            return;
		
		$msg = array();
		IF ($action=='PEND') {
		 	switch (kDatabaseType) {
				case 'oci': // Oracle
		 
					$sql='UPDATE RCAA_JOURNAL_HDR RCJH SET JEEXP_STAT = '.singlequote('PEND').' WHERE ID IN('.$idlist_text.') AND NVL(JEEXP_STAT,'.singlequote('.').')='.singlequote('.'). ' AND CLX_AUTH_STATUS= '.singlequote('AP') ;
				break;
				default:
						$sql='UPDATE RCAA_JOURNAL_HDR RCJH SET JEEXP_STAT = '.singlequote('PEND').' WHERE ID IN('.$idlist_text.') AND IFNULL(JEEXP_STAT,'.singlequote('.').')='.singlequote('.'). ' AND CLX_AUTH_STATUS= '.singlequote('AP');
					break;
			}
		//	e cho $sql;
			ClxCommon::$db->executequery($sql);
		//	P RE(ClxCommon::$db);
			switch (kDatabaseType) {	
				case 'oci':
			
					$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows);
				default:
					$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows);
			}	
		}
		
		else if ($action=='EXPT') { 
			/* Ejecutar Proces RCJX_SAP */
			
			 //pendiente por completar
			$processcode ='RCJX_SAP' ;
		//	$PRSC = &getTool('PRSC');
			$PRPR= &getTool('PRPR');
			$GLOBALS['record']=array();
			if (isset($_SESSION['user_record'])) {
				$GLOBALS['record']=$_SESSION['user_record'];	
				
			}
			//$PRSC->runProcessNow($processcode, $GLOBALS['record']);
			$PRPR->execute_process($processcode, $processcode);
			ob_clean();
			$contents.=$GLOBALS['CONTENTS_EXPORTS'];
			
			$sql='UPDATE RCAA_JOURNAL_HDR RCJH SET JEEXP_STAT = '.singlequote('EXP').' WHERE JEEXP_STAT ='.singlequote('PEND');
			ClxCommon::$db->executequery($sql);
			return $contents;
			
			
		} 
        return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
    }


    public function build_rctr_jump_action($action='') {
		
		
        $contents = '';
        $idlist = getIdlist();
		$idlist_text = implode(",",$idlist);
        if (empty($idlist))
            return;
		
		$msg = array();
		IF ($action=='ENLZ') {
			
			
			switch (kDatabaseType) {	
				case 'oci':
					$sql='SELECT LISTAGG(ID,'.singleQuote(',').') WITHIN GROUP (ORDER BY ID) IDS FROM RCAA_SUBLEDGER_TRANS RCTR WHERE ID IN('.$idlist_text.') AND ITEM_REF_NO IS NOT NULL ';
					$record=ClxCommon::$db->getOneRecord($sql);
					break;
				default:
					$record=ClxCommon::$db->getOneRecord($sql='SELECT GROUP_CONCAT(ID) IDS FROM RCAA_SUBLEDGER_TRANS RCTR WHERE  ID IN('.$idlist_text.') AND ITEM_REF_NO IS NOT NULL' );
					
			}
			
			
			$sql='UPDATE RCAA_SUBLEDGER_TRANS RCTR SET ITEM_REF_NO = '.singlequote('ENLZ').' WHERE ID IN('.$idlist_text.') AND ITEM_REF_NO IS NULL';
			ClxCommon::$db->executequery($sql);
			if (!empty($record['IDS'])) {
				$contents.="<br>".smsg('MSG-20191014120225',str_replace(',',' ,',$record['IDS'])); 	
			}
			else {
				$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows);
			}	
		}
		else if ($action=='DELZ') {
			/*switch (kDatabaseType) {	
				case 'oci':
					$sql='SELECT LISTAGG(ID,'.singleQuote(',').') WITHIN GROUP (ORDER BY ID) IDS FROM RCAA_SUBLEDGER_TRANS RCTR WHERE ID IN('.$idlist_text.') AND NVL(ITEM_REF_NO,'.singlequote('').')<>'.singlequote('ENLZ');
					$record=ClxCommon::$db->getOneRecord($sql);
					break;
				default:
					$record=ClxCommon::$db->getOneRecord($sql='SELECT GROUP_CONCAT(ID) IDS FROM RCAA_SUBLEDGER_TRANS RCTR WHERE  ID IN('.$idlist_text.') AND COALESCE(ITEM_REF_NO,'.singlequote('').')<>'.singlequote('ENLZ') );
			}
			$sql='UPDATE RCAA_SUBLEDGER_TRANS RCTR SET ITEM_REF_NO = NULL WHERE ID IN ('.$idlist_text.') AND ITEM_REF_NO = '.singlequote('ENLZ');
			ClxCommon::$db->executequery($sql);
			
			*/
			$sql='UPDATE RCAA_SUBLEDGER_TRANS SET ITEM_REF_NO = NULL ' .
						' WHERE  ID IN('.$idlist_text.') AND ITEM_REF_NO = '.singlequote('ENLZ');
			ClxCommon::$db->executequery($sql);
					
			
			if (!empty($record['IDS'])) {
				$contents.="<br>".smsg('MSG-20191014120225',str_replace(',',' ,',$record['IDS'])); 	
			}
			else {
				$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows);
			}		
		}
		else if ($action=='PROC') { 
			/*  Codigo 
1. validar que sume zero y generar mensaje
2. Generar nuevo no de referencia
3. Actualizar las transacciones con nuevo no de referencia
4. Mover registros fuentes al histórico
*/
			$sql='SELECT ITEM_REF_NO FROM RCAA_SUBLEDGER_TRANS WHERE ID ='.singleQuote($idlist_text);
			$ref=ClxCommon::$db->getOne($sql);
			IF ($ref<>'ENLZ') {
				$contents .= smsg('MSG-20191011171709');
			}
			else {
				
				switch (kDatabaseType) {	
					case 'oci':
						$record=ClxCommon::$db->getOneRecord($sql='SELECT SUM(TRANS_AMT) SUMX './*, LISTAGG(ID,'.singleQuote(',').')   WITHIN GROUP (ORDER BY ITEM_REF_NO) X */ 
								' FROM RCAA_SUBLEDGER_TRANS RES1  '.
								' WHERE  RES1.ITEM_REF_NO='.singlequote('ENLZ').' AND EXISTS (SELECT 1 FROM RCAA_SUBLEDGER_TRANS RES2 WHERE  RES1.EFFTDATE=RES2.EFFTDATE AND RES1.SUBACCOUNT_CODE	= RES2.SUBACCOUNT_CODE AND RES2.ID='.singleQuote($idlist_text).') GROUP BY RES1.SUBACCOUNT_CODE') ;
						break;
					default:
						$record=ClxCommon::$db->getOneRecord($sql='SELECT SUM(TRANS_AMT) SUMX '. /*GROUP_CONCAT(ID)  */ 
							' FROM RCAA_SUBLEDGER_TRANS RES1  '.
							' WHERE  RES1.ITEM_REF_NO='.singlequote('ENLZ').' AND EXISTS (SELECT 1 FROM RCAA_SUBLEDGER_TRANS RES2 WHERE RES1.EFFTDATE=RES2.EFFTDATE AND RES1.SUBACCOUNT_CODE= RES2.SUBACCOUNT_CODE AND RES2.ID='.singleQuote($idlist_text).') GROUP BY RES1.SUBACCOUNT_CODE' );
					//	echo $sql;
				}
				list($sum,$IDS)=array_values($record);
				switch (kDatabaseType) {
					case 'oci':
						$sql='SELECT TO_NUMBER(SUBSTR(NVL(MAX(ITEM_REF_NO),'.SINGLEQUOTE('000000000').'),-7)) GRP   FROM RCAA_SUBLEDGER_TRANS WHERE ITEM_REF_NO <> '.singlequote('ENLZ');// WHERE FORMCODE='.singlequote($record['UIFL_formcode']);
						break;
					default:
						$sql='SELECT CONVERT(RIGHT(MAX(ITEM_REF_NO),7),UNSIGNED INTEGER) GRP FROM RCAA_SUBLEDGER_TRANS WHERE ITEM_REF_NO <> '.singlequote('ENLZ');// WHERE FORMCODE='.singlequote($record['UIFL_formcode']);
				 }
				$ref=ClxCommon::$db->getOne($sql) ;
				$ref=SUBSTR('0000000'. ($ref+1),-7);
				//echo $sum;
				if (floatval($sum)==0) {
					$sql='UPDATE RCAA_SUBLEDGER_TRANS SET ITEM_REF_NO = '.singlequote($ref).  //' WHERE ID IN('.singlequote(str_replace(",",singlequote(','),$IDS)).')';
						' WHERE  RCAA_SUBLEDGER_TRANS.ITEM_REF_NO='.singlequote('ENLZ').' AND EXISTS (SELECT 1 FROM RCAA_SUBLEDGER_TRANS RES2 WHERE RCAA_SUBLEDGER_TRANS.EFFTDATE=RES2.EFFTDATE AND RCAA_SUBLEDGER_TRANS.SUBACCOUNT_CODE= RES2.SUBACCOUNT_CODE AND RES2.ID='.singleQuote($idlist_text).') ' );
					//	
					ClxCommon::$db->executequery($sql);
					$contents .= dict('GEL_LBL_OPER_NOT_ERR',ClxCommon::$db->affected_rows); // . '<br>' . $this->displayMsg;
				}
				else {
					 $contents .= smsg('MSG-20191011153733'); // . '<br>' . $this->displayMsg;
				}
				
				


			
				
			}		
			$this->move_registers();
		}		
		
          
        return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
    }
	function move_registers(){
		switch (kDatabaseType) {
            case 'oci':
				$sql0=' SELECT X.TABLE_CODE,X.TABLE_CODE_HIST, (SELECT CONCAT(MODULECODE,CONCAT('.singleQuote('_').',IDNAME)) FROM CLX_DB_TABLES WHERE TABLE_CODE=IDCODE AND ROWNUM<=1 ) TABLE_NAME,(SELECT CONCAT(MODULECODE,CONCAT('.singleQuote('_').',IDNAME)) TABLE_NAME_HIST FROM CLX_DB_TABLES WHERE TABLE_CODE_HIST=IDCODE AND ROWNUM<=1 ) TABLE_NAME_HIST FROM CLX_DB_TABLE_HIST X ';
				break;	
			default:
			     $sql0=' SELECT X.TABLE_CODE,X.TABLE_CODE_HIST, (SELECT CONCAT(MODULECODE,CONCAT('.singleQuote('_').',IDNAME)) FROM CLX_DB_TABLES WHERE TABLE_CODE=IDCODE LIMIT 1 ) TABLE_NAME,(SELECT CONCAT(MODULECODE,CONCAT('.singleQuote('_').',IDNAME)) TABLE_NAME_HIST FROM CLX_DB_TABLES WHERE TABLE_CODE_HIST=IDCODE LIMIT 1 ) TABLE_NAME_HIST FROM CLX_DB_TABLE_HIST X ';
		}	
		$table_hist=array();
		$rs = ClxCommon::$db->executeQuery($sql0);
		
		
		while ($tables = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$table_hist[$tables['TABLE_NAME']]=ARRAY($tables['TABLE_NAME_HIST'],$tables['TABLE_CODE'],$tables['TABLE_CODE_HIST']);
		}
		
		$sql1='SELECT DISTINCT DBTB.IDCODE TABLECODE, CONCAT(DBTB.MODULECODE,CONCAT('.singleQUote('_').',DBTB.IDNAME)) TABLENAME FROM CLX_DB_TABLES DBTB, 
		RCAA_SUBLEDGER_TRANS RCAA WHERE DBTB.IDCODE=RCAA.TABLECODE 
			UNION
			SELECT DISTINCT DBTB.IDCODE TABLECODE, CONCAT(DBTB.MODULECODE,CONCAT('.singleQUote('_').',DBTB.IDNAME)) TABLENAME FROM CLX_DB_TABLES DBTB, 
		RCAA_SUBLEDGER_TRANS RCAA WHERE DBTB.IDCODE=RCAA.TABLECODE2 ';
		$rs = ClxCommon::$db->executeQuery($sql1);
		
		while ($tablescode = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {//pre($tablescode);
			$FIELSD1='';
			$FIELSD2='';
			$sql='SELECT A.FIELDNAME FROM CLX_DB_TABLEFIELDS A, CLX_DB_TABLEFIELDS B WHERE A.TABLECODE='.singlequote($tablescode['TABLECODE']).' AND B.TABLECODE='.singleQUote($table_hist[$tablescode['TABLENAME']][2]).' AND A.FIELDNAME=B.FIELDNAME';
			$rsY =ClxCommon::$db->executequery($sql);
			$FIELSD1='';
			$FIELSD2='';
			$separ='';
			while ($resultY = ClxCommon::$db->getNextRecord($rsY, ASSOCIATIVE)) {//echo 'xxxxxxxxxxxx';
				$FIELSD1.=$separ.$resultY['FIELDNAME'];
				$FIELSD2.=$separ.'A.'.$resultY['FIELDNAME'];
				$separ=',';
			}
			$sql='INSERT INTO '.$table_hist[$tablescode['TABLENAME']][0]. '  ('.$FIELSD1.') '.
						 ' SELECT ' .$FIELSD2. ' FROM '.$tablescode['TABLENAME']. ' A  
						 WHERE 
							NOT EXISTS(
								SELECT 1 FROM '.$table_hist[$tablescode['TABLENAME']][0]. ' Y WHERE A.ID=Y.ID )
						  
						  AND EXISTS (
							SELECT 1 FROM RCAA_SUBLEDGER_TRANS X WHERE  ITEM_REF_NO<>'.singlequote('ENLZ').' AND
							(X.REC_ID=A.ID AND X.TABLECODE='.singleQuote($tablescode['TABLECODE']).  ' )
							UNION
							SELECT 1 FROM RCAA_SUBLEDGER_TRANS X WHERE ITEM_REF_NO<>'.singlequote('ENLZ').' AND
							 (X.REC_ID2=A.ID AND X.TABLECODE2='.singleQuote($tablescode['TABLECODE']). '))';
			ClxCommon::$db->executequery($sql);
			//$a=fopen(kPathToWebSite.'temp/salida3x.txt','a+');fwrite($a,$sql.chr(13).chr(10));fclose($a) ;


			///========================================================================
			
			


			$sql='DELETE FROM '.$tablescode['TABLENAME']. ' WHERE EXISTS(SELECT 1 FROM '.$table_hist[$tablescode['TABLENAME']][0].' X WHERE  X.ID='.$tablescode['TABLENAME'].'.ID)';
			ClxCommon::$db->executequery($sql);
			ClxCommon::$db->executequery('COMMIT');
		}
		
	}
	/*
	function rcjh_validate_form($record, &$msg){
		$idlist = getIdlist();
		$contents='';
		IF ($record['RCJH_EFFTDATE'] >$record['RCJH_REAL_DATE']) {
			$msg['RCJH_EFFTDATE']=dict('FE_ME_FE_REAL');
		}
		if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' ) {
			$rcjh_res=ClxCommon::$db->getOneRecord($sql='SELECT CASE WHEN SUM(COALESCE(DEBIT_AMT,0)) - SUM(COALESCE(CREDIT_AMT,0)) =0 THEN 0 ELSE 1 END DIFERENCIA FROM RCAA_JOURNAL_HDR RCJH,RCAA_JOURNAL_LINES X WHERE X.RCJH_CODE=RCJH.IDCODE AND RCJH.ID='.$idlist[0]);
		//	ECHO $sql;		
			if 	($rcjh_res['DIFERENCIA']==1) {
				$contents=$msg['RCJL_DEBIT_AMT']=dict('mount_cre_deb_0');
						
				return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
			}
		}
		
	}*/
	function rcjh_validate_form($record, &$msg){
		//pre($record);	
		//pre(UserRequest::$request);
		//pre($msg);
		//pre($GLOBALS);
		//$idlist = implode(",",$idli=getIdlist());
		//if (empty($idlist))
		//	return false;
		//for ($t=0;$t<count($idli);$t++) {
		//	unset (UserRequest::$request['selector_'.$idli[$t]]);
		//	unset (UserRequest::$post['selector_'.$idli[$t]]);
		//}
		$contents='';
		IF ($record['RCJH_EFFTDATE'] >$record['RCJH_REAL_DATE']) {
			$msg['RCJH_EFFTDATE']=dict('FE_ME_FE_REAL');
		}
		
		
		if (UserRequest::$request['ac'] === 'DELETE') {
			if (empty($record['idlist']) && isset(UserRequest::$request['idlist'])) {
				$record['idlist']=UserRequest::$request['idlist'];
			}
			$sql='SELECT RCJH.CLX_AUTH_STATUS,IDCODE FROM RCAA_JOURNAL_HDR RCJH WHERE RCJH.ID ='.$record['idlist'];		
			$rs=ClxCommon::$db->executequery($sql);
			$record2= ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE);
			UserRequest::$request['RCJH_IDCODE']=$record2['IDCODE'];
			$CLX_AUTH_STATUS=$record2['CLX_AUTH_STATUS'];
			
			if ($CLX_AUTH_STATUS==='AP'){
				$msg['RCJL_RCJH_CODE']=dict('CODE_ERR_INVALID_STATUS_JOURNAL',UserRequest::$request['RCJH_IDCODE']);
				addmessage($msg['RCJL_RCJH_CODE']);
				return false;
			}
		
		}	
		
		else if ($record['RCJH_CLX_AUTH_STATUS']=='AP' ) {
			$msg['RCJH_CLX_AUTH_STATUS']=dict('CODE_ERR_INVALID_STATUS');
		}
		if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' ) {
			$rs=ClxCommon::$db->executequery($sql='SELECT IDCODE, CASE WHEN SUM(COALESCE(DEBIT_AMT,0)) - SUM(COALESCE(CREDIT_AMT,0)) =0 THEN 0 ELSE 1 END DIFERENCIA,COUNT(1)CUENTA FROM RCAA_JOURNAL_HDR RCJH,RCAA_JOURNAL_LINES X WHERE X.RCJH_CODE=RCJH.IDCODE AND RCJH.IDCODE= '.singlequote($record['RCJH_IDCODE']).' GROUP BY RCJH.IDCODE ');
			$truecount=0;
			if ($rcjh_res = ClxCommon::$db->getNextRecord($rs)) {
				$truecount=$rcjh_res['CUENTA'];
				if 	($rcjh_res['DIFERENCIA']==1) {
					$contents=$msg['RCJL_DEBIT_AMT']=dict('mount_cre_deb_0',$rcjh_res['IDCODE']);
					return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
				}
				
				
			}	
			if ($truecount<2) {
				$contents=$msg['RCJH_IDCODE']=dict('JOURNAL_LINES_NOT_FOUND',$record['RCJH_IDCODE']);
				return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
				
			}
		}
		
	}
	
	
	function rcjl_validate_form($record, &$msg){
		
		$CLX_AUTH_STATUS='';
		if (UserRequest::$request['ac'] === 'DELETE') {
			if (empty($record['idlist']) && isset(UserRequest::$request['idlist'])) {
				$record['idlist']=UserRequest::$request['idlist'];
			}
			$sql='SELECT RCJH.IDCODE ,RCJH.CLX_AUTH_STATUS FROM RCAA_JOURNAL_HDR RCJH,RCAA_JOURNAL_LINES RCJL WHERE RCJL.RCJH_CODE=RCJH.IDCODE AND RCJL.ID ='.$record['idlist'];		
			$rs=ClxCommon::$db->executequery($sql);
			$record2= ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE);
			UserRequest::$request['RCJL_RCJH_CODE']=$record2['IDCODE'];
			$CLX_AUTH_STATUS=$record2['CLX_AUTH_STATUS'];
			
			
		}
		if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'MODIFY'|| UserRequest::$request['ac'] === 'DUPLICATE') {
			$sql='SELECT RCJH.CLX_AUTH_STATUS FROM RCAA_JOURNAL_HDR RCJH WHERE RCJH.IDCODE= '.singlequote(UserRequest::$request['RCJL_RCJH_CODE']);
			$CLX_AUTH_STATUS=ClxCommon::$db->getOne($sql);
		}	
		if ($CLX_AUTH_STATUS==='AP'){
			if (UserRequest::$request['ac'] === 'DELETE') {
				$msg['RCJL_RCJH_CODE']=dict('CODE_ERR_INVALID_STATUS_JOURNAL',UserRequest::$request['RCJL_RCJH_CODE']);
				addmessage($msg['RCJL_RCJH_CODE']);
			
				return false;
			}
			else {
				$msg['RCJL_RCJH_CODE']=dict('CODE_ERR_INVALID_STATUS_JOURNAL',"");
				$contents=dict('CODE_ERR_INVALID_STATUS_JOURNAL',UserRequest::$request['RCJL_RCJH_CODE']);
				return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
		}
		
	}
			
	
}

	function rctr_validate_form(&$record, &$msg){
		$contents=''; 
		//p re($record);
		if ($record['RCTR_CLX_AUTH_STATUS']==='AP'){
				$msg['RCTR_CLX_AUTH_STATUS']=dict('CODE_ERR_INVALID_STATUS_RCTR');
		}

		// VALIDACION PARA ITEMS DE CONCILIACION CONTRA EL MONTO MAXIMO AUTORIZADO POR CUENTA CONTABLE
		
		// Search Account Max Authorized Amount en el catalogo de cuentas.
		/*  -- 20200405-SA: Se modifica la busqueda de la Cuenta Contable agregando el Grupo Contable como criterio 
		$sql='SELECT RCAC.MAX_AUTH_AMT FROM RCAA_CODES_TBL RCAC WHERE RCAC.IDCODE =' . singlequote($record['RCTR_SUBACCOUNT_CODE']);
		*/
		$sql='SELECT RCAC.MAX_AUTH_AMT FROM RCAA_CODES_TBL RCAC, RCAA_LEDGERS_TBL RCLE WHERE RCAC.IDCODE =' . singlequote($record['RCTR_SUBACCOUNT_CODE']) . 
			' AND RCLE.IDCODE = ' . singlequote($record['RCTR_RCLE_CODE']) . ' AND RCAC.RCAG_CODE = RCLE.RCAG_CODE' ;
		$MAX_AUTH_AMT=ClxCommon::$db->getOne($sql);

		if ($record['RCTR_RECON_ITEM']==1 && $record['RCTR_REC_SRC']=='ON' && abs($record['RCTR_TRANS_AMT']) > abs($MAX_AUTH_AMT) ) {
				$msg['RCTR_TRANS_AMT']=dict('CODE_ERR_ITEM_GT_MAX_AMT', $MAX_AUTH_AMT);
		}
/*		else { 
			$record['CLX_AUTH_STATUS']= 'AP';
		}
*/		
	}
	
	function rctr_approve_item(&$record, &$msg){
		$contents=''; 
		// VALIDACION PARA ITEMS DE CONCILIACION CONTRA EL MONTO MAXIMO AUTORIZADO POR CUENTA CONTABLE
		
		// Search Account Max Authorized Amount en el catalogo de cuentas.
		$sql='SELECT RCAC.MAX_AUTH_AMT FROM RCAA_CODES_TBL RCAC, RCAA_LEDGERS_TBL RCLE WHERE RCAC.IDCODE =' . singlequote($record['SUBACCOUNT_CODE']) . 
			' AND RCLE.IDCODE = ' . singlequote($record['RCLE_CODE']) . ' AND RCAC.RCAG_CODE = RCLE.RCAG_CODE' ;
		$MAX_AUTH_AMT=ClxCommon::$db->getOne($sql);

		if ($record['RECON_ITEM']==1 && $record['REC_SRC']=='ON' && abs($record['TRANS_AMT']) <= abs($MAX_AUTH_AMT) ) {
			$record['CLX_AUTH_STATUS']= 'AP';
		}
	}

}

