<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-04-20 08:37:18 -0400 (Fri, 20 Apr 2018) $
 * @version        $Rev: 9795 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Rcta {
    
    function Rcta($procParameters = array()) {
		$tta=fopen(kPathToWebSite."/".kPathToTemp."archivorcta2.txt","a+");
		fclose($tta);
        multiTableName($this, array('RCTA'));
       // $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
    }

    /**
     * Action from jump listing
     */
    public function build_rcta_jump_action($action='') {
		
		
        $contents = '';
        $idlist = getIdlist();
		$idlist_text = implode(",",$idlist);
        if (empty($idlist))
            return;
		
			
		$msg = array();
		IF ($action=='ENLZ') {
			$sql='UPDATE RCAA_SUBLEDGER_TRANS RCTR SET ITEM_REF_NO = '.singlequote('ENLZ').' WHERE ID IN('.$idlist_text.') AND ITEM_REF_NO IS NULL';
			ClxCommon::$db->executequery($sql);
			$contents .= dict('GEL_LBL_OPER_COMP_SUCCESS');
		}
		else if ($action=='DELZ') {
			$sql='UPDATE RCAA_SUBLEDGER_TRANS RCTR SET ITEM_REF_NO = NULL WHERE ID IN ('.$idlist_text.') AND ITEM_REF_NO = '.singlequote('ENLZ');
			ClxCommon::$db->executequery($sql);
			$contents .= dict('GEL_LBL_OPER_COMP_SUCCESS');
		}
		else if ($action=='PROC') { 
			/*  Codigo 
1. validar que sume zero y generar mensaje
2. Generar nuevo no de referencia
3. Actualizar las transacciones con nuevo no de referencia
4. Mover registros fuentes al histórico
*/
			$sql='SELECT ITEM_REF_NO FROM RCAA_SUBLEDGER_TRANS WHERE ID ='.singleQuote($idlist_text);
			$ref=ClxCommon::$db->getOne($sql);
			IF ($ref<>'ENLZ') {
				$contents .= smsg('MSG-20191011171709');
			}
			else {
				switch (kDatabaseType) {	
					case 'oci':
						$record=ClxCommon::$db->getOneRecord($sql='SELECT SUM(BASE_TRANS_AMT) SUMX,LISTAGG(ID,'.singleQuote(',').')  WITHIN GROUP (ITEM_REF_NO) X FROM RCAA_SUBLEDGER_TRANS RES1  '.
								' WHERE  RES1.ITEM_REF_NO='.singlequote('ENLZ').' AND EXISTS (SELECT 1 FROM RCAA_SUBLEDGER_TRANS RES2 WHERE RES1.SUBACCOUNT_CODE	= RES2.SUBACCOUNT_CODE AND RES2.ID='.singleQuote($idlist_text).') GROUP BY RES1.SUBACCOUNT_CODE') ;
						break;
					default:
						$record=ClxCommon::$db->getOneRecord($sql='SELECT SUM(BASE_TRANS_AMT) SUMX,GROUP_CONCAT(ID) FROM RCAA_SUBLEDGER_TRANS RES1  '.
							' WHERE  RES1.ITEM_REF_NO='.singlequote('ENLZ').' AND EXISTS (SELECT 1 FROM RCAA_SUBLEDGER_TRANS RES2 WHERE RES1.SUBACCOUNT_CODE= RES2.SUBACCOUNT_CODE AND RES2.ID='.singleQuote($idlist_text).') GROUP BY RES1.SUBACCOUNT_CODE' );
						
				}
				list($sum,$IDS)=array_values($record);
				switch (kDatabaseType) {
					case 'oci':
						$sql='SELECT TO_NUMBER(SUBSTR(NVL(MAX(ITEM_REF_NO),'.SINGLEQUOTE('000000000').'),-7)) GRP   FROM RCAA_SUBLEDGER_TRANS WHERE ITEM_REF_NO <> '.singlequote('ENLZ');// WHERE FORMCODE='.singlequote($record['UIFL_formcode']);
						break;
					default:
						$sql='SELECT CONVERT(RIGHT(MAX(ITEM_REF_NO),7),UNSIGNED INTEGER) GRP FROM RCAA_SUBLEDGER_TRANS WHERE ITEM_REF_NO <> '.singlequote('ENLZ');// WHERE FORMCODE='.singlequote($record['UIFL_formcode']);
				 }
				$ref=ClxCommon::$db->getOne($sql) ;
				$ref=SUBSTR('0000000'. ($ref+1),-7);
				if (floatval($sum)==0) {
					$sql='UPDATE RCAA_SUBLEDGER_TRANS RCTR SET ITEM_REF_NO = '.singlequote($ref).' WHERE ID IN('.singlequote(str_replace(",",singlequote(','),$IDS)).')';
					ClxCommon::$db->executequery($sql);
					$contents .= dict('GEL_LBL_OPER_COMP_SUCCESS'); // . '<br>' . $this->displayMsg;
				}
				else {
					 $contents .= smsg('MSG-20191011153733'); // . '<br>' . $this->displayMsg;
				}
			}		
		}		
		
          
        return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_DATA, $contents, ''). '<Br>';
    }


  

}
